VERSION 5.00
Begin VB.UserControl UniText 
   Appearance      =   0  '
   BackColor       =   &H80000005&
   ClientHeight    =   1275
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2970
   EditAtDesignTime=   -1  'True
   KeyPreview      =   -1  'True
   ScaleHeight     =   85
   ScaleMode       =   3  '
   ScaleWidth      =   198
End
Attribute VB_Name = "UniText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*************************************************************************************************
'* UniText 0.9 - Unicode textbox user control
'* ------------------------------------------
'* By Vesa Piittinen aka Merri, http://vesa.piittinen.name/ <vesa@piittinen.name>
'* Unicode on NT4/2000/XP+; (ANSI fallback on 95/98/ME MISSING)
'*
'* Copyright free, use and abuse as you see fit. No need to ask for permissions.
'* However, I do respect e-mail and credits where appropriate :)
'*
'* VERSION HISTORY
'* ---------------
'* 0.9 BETA (2007-12-08)
'* - Initial version
'*************************************************************************************************

Option Explicit

Public Event Change()
Public Event Click(Button As UniTextMouseButton)
Public Event ContextMenu(Cancel As Boolean)
Public Event DblClick(Button As UniTextMouseButton)
Public Event KeyDown(KeyCode As Integer, Shift As UniTextShift)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As UniTextShift)
Public Event MouseDown(Button As UniTextMouseButton, Shift As UniTextShift, X As Single, Y As Single)
Public Event MouseEnter()
Public Event MouseLeave()
Public Event MouseMove(Button As UniTextMouseButton, Shift As UniTextShift, X As Single, Y As Single)
Public Event MouseUp(Button As UniTextMouseButton, Shift As UniTextShift, X As Single, Y As Single)
Public Event Update()

Private Enum TRACKMOUSEEVENT_FLAGS
    TME_HOVER = &H1&
    TME_LEAVE = &H2&
    TME_QUERY = &H40000000
    TME_CANCEL = &H80000000
End Enum

Public Enum UniTextBorderStyle
    [No Border] = 0&
    [Flat3D] = 1&
    [3D] = 2&
End Enum

' Mouse button constants
Public Enum UniTextMouseButton
    [No Button] = 0
    [Left Button] = vbLeftButton
    [Right Button] = vbRightButton
    [Left And Right Button] = vbLeftButton Or vbRightButton
    [Middle Button] = vbMiddleButton
    [Left And Middle Button] = vbLeftButton Or vbMiddleButton
    [Right And Middle Button] = vbRightButton Or vbMiddleButton
    [All Buttons] = vbLeftButton Or vbRightButton Or vbMiddleButton
End Enum

' Shift constants
Public Enum UniTextShift
    [No Mask] = 0
    [Shift Mask] = vbShiftMask
    [Ctrl Mask] = vbCtrlMask
    [Shift And Ctrl Mask] = vbShiftMask Or vbCtrlMask
    [Alt Mask] = vbAltMask
    [Shift And Alt Mask] = vbShiftMask Or vbAltMask
    [Ctrl And Alt Mask] = vbCtrlMask Or vbAltMask
    [All Masks] = vbShiftMask Or vbCtrlMask Or vbAltMask
End Enum

Private Const BDR_INNER = &HC
Private Const BDR_OUTER = &H3
Private Const BDR_RAISED = &H5
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKEN = &HA
Private Const BDR_SUNKENINNER = &H8
Private Const BDR_SUNKENOUTER = &H2
Private Const BF_BOTTOM = &H8
Private Const BF_LEFT = &H1
Private Const BF_RIGHT = &H4
Private Const BF_TOP = &H2
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)

Private Const FW_BOLD = 700
Private Const FW_NORMAL = 400
Private Const LF_FACESIZE = 32
Private Const LOGPIXELSX = 88
Private Const LOGPIXELSY = 90

Private Const EN_ALIGN_LTR_EC = &H700&
Private Const EN_ALIGN_RTL_EC = &H701&
Private Const EN_CHANGE = &H300&
Private Const EN_HSCROLL = &H601&
Private Const EN_UPDATE = &H400&
Private Const EN_VSCROLL = &H602&

Private Const EM_SETPASSWORDCHAR = &HCC&

Private Const ES_AUTOVSCROLL = &H40&
Private Const ES_AUTOHSCROLL = &H80&
Private Const ES_MULTILINE = &H4&
Private Const ES_NOHIDESEL = &H100&
Private Const ES_PASSWORD = &H20&
Private Const ES_READONLY = &H800&
Private Const ES_WANTRETURN = &H1000&

Private Const GWL_EXSTYLE As Long = -20&
Private Const GWL_STYLE As Long = -16&

Private Const VK_DOWN = &H28
Private Const VK_END = &H23
Private Const VK_HOME = &H24
Private Const VK_LEFT = &H25
Private Const VK_RIGHT = &H27
Private Const VK_UP = &H26

Private Const WS_CHILD = &H40000000
Private Const WS_HSCROLL = &H100000
Private Const WS_TABSTOP = &H10000
Private Const WS_VISIBLE = &H10000000
Private Const WS_VSCROLL = &H200000

' WM_MOUSEMOVE and others
Private Const MK_LBUTTON = &H1&
Private Const MK_RBUTTON = &H2&
Private Const MK_SHIFT = &H4&
Private Const MK_CONTROL = &H8&
Private Const MK_MBUTTON = &H10&

' window messages
Private Const WM_COMMAND = &H111&
Private Const WM_CONTEXTMENU = &H7B&
Private Const WM_CREATE = &H1&
Private Const WM_CTLCOLOREDIT = &H133&
Private Const WM_CTLCOLORSTATIC = &H138&
Private Const WM_DESTROY = &H2&
Private Const WM_ERASEBKGND = &H14
Private Const WM_GETTEXT = &HD
Private Const WM_GETTEXTLENGTH = &HE
Private Const WM_KEYDOWN = &H100
Private Const WM_KEYUP = &H101
Private Const WM_KILLFOCUS = &H8
Private Const WM_LBUTTONDBLCLK = &H203&
Private Const WM_LBUTTONDOWN = &H201&
Private Const WM_LBUTTONUP = &H202&
Private Const WM_MBUTTONDBLCLK = &H209&
Private Const WM_MBUTTONDOWN = &H207&
Private Const WM_MBUTTONUP = &H208&
Private Const WM_MOUSEMOVE = &H200&
Private Const WM_MOUSELEAVE = &H2A3&
Private Const WM_PAINT = &HF&
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_RBUTTONDOWN = &H204&
Private Const WM_RBUTTONUP = &H205&
Private Const WM_SETFOCUS = &H7
Private Const WM_SETFONT = &H30
Private Const WM_SETTEXT = &HC

Private Const OPAQUE = 2
Private Const TRANSPARENT = 1

Private Type CWPSTRUCT
    lParam As Long
    wParam As Long
    Message As Long
    hWnd As Long
End Type

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(31) As Byte
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type TRACKMOUSEEVENT_STRUCT
    cbSize As Long
    dwFlags As TRACKMOUSEEVENT_FLAGS
    hWndTrack As Long
    dwHoverTime As Long
End Type

Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function LoadLibraryA Lib "kernel32" (ByVal lpLibFileName As String) As Long

Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal Edge As Long, ByVal grfFlags As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function InvalidateRect Lib "user32" (ByVal hWnd As Long, lpRECT As RECT, ByVal bErase As Long) As Long
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
Private Declare Function SetFocus Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function TrackMouseEventUser32 Lib "user32" Alias "TrackMouseEvent" (lpEventTrack As TRACKMOUSEEVENT_STRUCT) As Long
Private Declare Function TrackMouseEventComCtl Lib "comctl32" Alias "_TrackMouseEvent" (lpEventTrack As TRACKMOUSEEVENT_STRUCT) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function CreateWindowExW Lib "user32" (ByVal dwExStyle As Long, ByVal lpClassName As Long, ByVal lpWindowName As Long, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetACP Lib "kernel32" () As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Declare Function SendMessageW Lib "user32" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpDefaultChar As Long, lpUsedDefaultChar As Long) As Long

Dim m_BorderStyle As UniTextBorderStyle
Dim m_ForeColor As OLE_COLOR
Dim m_HasFocus As Boolean
Dim m_Locked As Boolean
Dim m_MouseOver As Boolean
Dim m_MultiLine As Boolean
Dim m_PasswordChar As String
Dim m_ScrollBars As ScrollBarConstants
Dim m_Text As String
Dim m_UseEvents As Boolean

Dim m_BackClr As Long
Dim m_BackClrBrush As Long
Dim m_bytText() As Byte
Dim m_ForeClr As Long
Dim m_hDC As Long
Dim m_hFnt As Long
Dim m_hWnd As Long
Dim m_MenuhWnd As Long
Dim m_RC As RECT
Dim m_ScaleMode As ScaleModeConstants   ' Container ScaleMode
Dim m_TrackComCtl As Boolean
Dim m_TrackUser32 As Boolean

' for fixing XP Theme problem with a certain version of comctl32.dll
Dim m_FreeShell32 As Boolean
Dim m_Shell32 As Long

Dim blnDesignTime As Boolean           ' True if in IDE design time

' SelfSub - LaVolpe's version
' ---------------------------
'
' Paul Caton has done some amazing things combining ASM and VB.  Unfortunately, he has moved
' on from VB and left this code to me. His original code can be found at the links provided
' below. I am taking the initiative to learn from his thunks, update, rewrite, or otherwise
' improve those thunks. Therefore, some of this code will differ significantly from Paul's
' original work. As an ASM newbie, I welcome any suggestions/corrections for the ASM code itself.

' If you are new to these thunking routines, here is the basic idea:
' 1. Make subclassing, hooking, callbacks IDE-safe. No crashes due to END or STOP
' 2. Be able to allow subclassing, hooking, callbacks to use a class, form,
'       property page or usercontrol to call back to (just like an AddressOf pointer)
' 3. Allow that 'AddressOf' pointer to exist in any VB code object

' Original work done by Paul Caton. Contributions made by Tai Chi Minh Ralph Eastwood and myself
'   Caton> http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=64867&lngWId=1
'   Caton> http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=51403&lngWId=1
'   Eastwood> http://www.planet-source-code.com/vb/scripts/ShowCode.asp?txtCodeId=66665&lngWId=1

' This Post> http://www.planet-source-code.com/vb/scripts/ShowCode.asp?lngWId=1&txtCodeId=68737

' I have now completely revamped the subclassing ASM. It is larger than Paul's original work but I believe
' it is now 100% END safe, IDE-safe. I have even placed END statements inside of the callback procedures
' and IDE did not crash.  The additional ASM code added to Paul's original work, included use of a
' self-killing delay timer that keeps the ASM alive in virtual memory and doubles as a trigger to
' delete the virtual memory.

' The issue with Paul's code regarding usercontrols that subclass ContainerHwnd multiple times has been
' resolved with the use of the timers.  How that specific situation was resolved is briefly explained:

'     FYI: Usercontrol (UC) issues when subclassing same parent window multiple times & how timer prevents crash
'     A = the ContainerHwnd's original window procedure
'     ucB loads & subclasses ContainerHwnd, B now ContainerHwnd's procedure, A is previous
'     ucC loads & subclasses ContainerHwnd, C now ContainerHwnd's procedure, B is previous
'     ucD loads & subclasses ContainerHwnd, D now ContainerHwnd's procedure, C is previous
'     When unloading occurs in VB, the first loaded is first unloaded
'       and children are unloaded before the parent/ContainerHwnd.....
'     ucB unloads and changes ContainerHwnd's procedure to A - good, is original procedure
'     ucC unloads and changes ContainerHwnd's procedure to B - bad because B is dead
'     ucD unloads and changes ContainerHwnd's procedure to C - bad because C is dead
'     ContainerHwnd unloads and message sent to C -- crash because C is dead
'
'     Delay timer prevents this from occurring by keeping each alive and, within
'         this thunk, the bBypassing flag is set when UC was destroyed. So to
'         continue on, here is what happens when ContainerHwnd unloads using delay mechanism
'     .... ContainerHwnd unloads and message sent to C (kept alive until timer fires)
'     .... C gets message, Bypass is active, sets ContainerHwnd's procedure to B
'     .... B gets message, Bypass is active, sets ContainerHwnd's procedure to A - where we want to be
'     .... Timers fire and clear memory for C & B in that order

'    Hooking issues have now been resolved too. The issue with hooks is similar to that with subclassing.
'    When a hook is established and user hits END, cleanup cannot occur and hook remains.  Unfortunately,
'    END does not trigger messages to let the thunk know that END occurred; whereas with subclassing,
'    END terminates windows and that generates messages. Now, depending on the hook type, you may not get
'    another message for awhile until it is triggered. Well, the object containing the callback was destroyed
'    by END, and the next message the hook receives will try to forward it to the destroyed object - crash.
'    So, the fix is to determine if the object containing the callback changed and if it was,
'    then do not allow callbacks to that object.  Hook thunk memory is never released when END is executed.
'    Hook memory release only occurs during normal shutdown, via shk_TerminateHooks, and when VB is closed.

' Other subclassing thunk modifications/enhancements are listed below:
'   - thunks can also be used inside of property pages if so desired
'   - subclassing thunks will automatically release after window processes WM_NCDestroy message (last message a window gets)
'   - subclassing thunks can destroy a parent-less API window that is subclassed, when IDE ends (optional parameter)
'   - as mentioned above, use of a delay timer appears to make subclasser 100% safe, crash-proof
'   - callback thunks can be individually set & released
'   - callback thunks have optional parameter to auto-kill timers when IDE ends
'   - hook thunks can filter on before and/or after messages just like the subclassing thunks

'   Above all being said, the ASM thunks are but a small part of what Paul Caton put together.
'   Without his zAddressOf and zProbe functions, easy subclassing and containment would not
'   be where it is right now. We all owe him a bow of respect for that.

' Unicode is supported in subclassing and hooking. Not applicable with callbacks because pointers are only used.
'   - Since VB windows are not unicode windows, unicode support is not provided by default
'       However, VB can create unicode windows via CreateWindowExW, therefore...
'   - To request unicode support, supply the appropriate parameter to the ssc_Subclass and/or shk_SetHook routines
'       -- check the bUnicode parameter's return value to validate success
'       -- if successful, ensure you use unicode API calls, unicode strings as needed
'           --- Exceptions. If either the following tests (depending on situation) returns false, unicode will not be used
'           1) Subclassing: The window being subclassed must return non-zero from IsWindowUnicode(hWnd)
'           2) Hooking: Non-zero must be returned from IsWindowUnicode(GetDesktopWindow)


' *******************************************************************************************************************
'       THE ENTIRE CLASS OR PARTS HEREIN CAN ALSO BE ADDED TO A FORM, USERCONTROL (UC), or PROPERTY PAGE (PPG)
'       ALLOWING SUBCLASSING, HOOKING, CALLBACKS CONTAINMENT WITHIN THE FORM/UC/PPG ITSELF.
' *******************************************************************************************************************


' This consolidated subclassing, hooking, callback class can be used as is or
' can be picked apart to create your own class including one or more of the
' IDE-safe thunks:  subclassing, hooking, and/or callbacks

' Should you want to simply extract one or more of the thunkers, they are separated
' below with comments on what to include from this class. Some routines are designed
' to be made public so that they can be called from outside of this class. In the
' comments below, those that fall into this category are identified. Because they
' are designed to be public, they wrap a similar Private routine. If you don't want
' to make those routines public, you can remove them and simply call the wrapped
' routine directly. Comments exist in those routines to add more info if needed.

'========================================================================================================
' COMMON-USE ITEMS USED IN ALL THUNKS
'========================================
'   Routines: must include these regardless if using subclassing, hooking, callbacks
'         zError - returns error information as needed; entire routine can be rem'd out if you so desire
'         zFnAddr - Returns the AddressOf pointer for API DLL functions
'         zMap_VFunction - returns memory handle to the ASM for a specific thunk
'         zAddressOf - returns the AddressOf function pointer for a form/uc/class/ppg routine.
'         zProbe - a worker function for zAddressOf
'         zData (Get/Let) - used to set/get subclass related data
'         zInIDE - used to determine if running IDE or not
'         zUnThunk - used to release a specific subclass, hook or callback
'         zTerminateThunks - used to release all subclasses, hooks or callbacks
'     all above are local use only routines. Do not make public
'     jump to zMap_Function. All common routines start there, copy & paste as needed
  
  ' Local variables/constants: must declare these regardless if using subclassing, hooking, callbacks
    Private z_scFunk            As Collection   'hWnd/thunk-address collection; initialized as needed
    Private z_hkFunk            As Collection   'hook/thunk-address collection; initialized as needed
    Private z_cbFunk            As Collection   'callback/thunk-address collection; initialized as needed
    Private Const IDX_INDEX     As Long = 2     'index of the subclassed hWnd OR hook type
    Private Const IDX_PREVPROC  As Long = 9     'Thunk data index of the original WndProc
    Private Const IDX_BTABLE    As Long = 11    'Thunk data index of the Before table for messages
    Private Const IDX_ATABLE    As Long = 12    'Thunk data index of the After table for messages
    Private Const IDX_CALLBACKORDINAL As Long = 36 ' Ubound(callback thunkdata)+1, index of the callback

  ' Declarations:
    Private Declare Sub RtlMoveMemory Lib "kernel32" (ByVal Destination As Long, ByVal Source As Long, ByVal Length As Long)
    Private Declare Function IsBadCodePtr Lib "kernel32" (ByVal lpfn As Long) As Long
    Private Declare Function VirtualAlloc Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
    Private Declare Function VirtualFree Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
    Private Declare Function GetModuleHandleA Lib "kernel32" (ByVal lpModuleName As String) As Long
    Private Declare Function GetModuleHandleW Lib "kernel32" (ByVal lpModuleName As Long) As Long
    Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
    Private Enum eThunkType
        SubclassThunk = 0
        HookThunk = 1
        CallbackThunk = 2
    End Enum


'========================================================================================================
' TO USE IDE-SAFE SUBCLASSING...
'===============================
'   Special Notes:
'     a. ssc_Subclass uses function ordinals. Last routine in the class/form/uc/ppg is Ordinal #1, second to last is Ordinal #2, etc
'           IMPORTANT: Routines used for subclass procedure MUST NOT be Public, can be Private or Friend
'     b. VB5 users. Search for zFnAddr("vba6", "EbMode") and replace with zFnAddr("vba5", "EbMode")
'     c. Do not terminate application while stopped in the subclass procedure
'     d. At a minimum, review ssc_Subclass, ssc_Unsubclass & ssc_Terminate
'
'   1. Include all common-use items above
'   2. Include the following routines:  ssc_ = self-subclassing
'       ssc_Subclass - used to initiate a subclassing session
'    -  ssc_Terminate - used to terminate all subclassing sessions
'    -  ssc_UnSubclass - used to terminate a single subclassing session
'       ssc_AddMsg - adds a message to subclass
'       ssc_DelMsg - removes a message from subclassing
'    -  ssc_CallOrigWndProc - enables the CallWindowProc API function on subclassed windows
'    -  zGet_lParamUser, zSet_lParamUser - returns/replaces the optional lParamUser set in ssc_Subclass & shk_SetHook
'    *  zAddMsg - this does the work of ssc_AddMsg. See above
'    *  zDelMsg - this does the work of ssc_DelMsg. See above
'  (*) are local use only, do not make public. All others can be made public if desired
'  (-) can be removed if not needed. See their routine's comments
'   3. In your form/uc/class/ppg unload/terminate event, include the statement: ssc_Terminate or zTerminateThunks SubclassThunk
'   4. Include the generic window procedure routine: myWndProc at bottom of this module
'   5. Also include the following declarations
  
    '-Selfsub specific declarations----------------------------------------------------------------------------
    Private Enum eMsgWhen                                                   'When to callback
      MSG_BEFORE = 1                                                        'Callback before the original WndProc
      MSG_AFTER = 2                                                         'Callback after the original WndProc
      MSG_BEFORE_AFTER = MSG_BEFORE Or MSG_AFTER                            'Callback before and after the original WndProc
    End Enum
    
    ' see ssc_Subclass for complete listing of indexes and what they relate to
    Private Const IDX_PARM_USER As Long = 13    'Thunk data index of the User-defined callback parameter data index
    Private Const IDX_UNICODE   As Long = 107   'Must be UBound(subclass thunkdata)+1; index for unicode support
    Private Const MSG_ENTRIES   As Long = 32    'Number of msg table entries. Set to 1 if using ALL_MESSAGES for all subclassed windows
    Private Const ALL_MESSAGES  As Long = -1    'All messages will callback
    
    Private Declare Function CallWindowProcA Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Private Declare Function CallWindowProcW Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Private Declare Function GetCurrentProcessId Lib "kernel32" () As Long
    Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
    Private Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
    Private Declare Function IsWindowUnicode Lib "user32.dll" (ByVal hWnd As Long) As Long
    Private Declare Function SetWindowLongA Lib "user32" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
    Private Declare Function SetWindowLongW Lib "user32" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
'-------------------------------------------------------------------------------------------------

'========================================================================================================
' TO USE IDE-SAFE HOOKING...
'==============================
'   Special Notes:
'     a. shk_SetHook uses function ordinals. Last routine in the class/form/uc is Ordinal #1, second to last is Ordinal #2, etc
'           IMPORTANT: Routines used for hooks MUST NOT be Public, can be Private or Friend
'     b. VB5 users. Search for zFnAddr("vba6", "EbMode") and replace with zFnAddr("vba5", "EbMode")
'     c. When END executed, app does not crash, but hook may not be released immediately. Should you notice this,
'        simply do something that would trigger the hook (i.e., move  mouse, keystroke, depending on hook type).
'        The hook then will release.
'     d. Do not terminate application while stopped in the hook procedure
'     e. At a minimum, review shk_SetHook, shk_Unhook & shk_TerminateHooks
'
'   1. Include all common-use items from above "common-use" section
'   2. Include the following routines:  shk_ = self-Hooking
'       shk_SetHook - used to initiate a hooking session
'    -  shk_TerminateHooks - used to terminate all hooks
'    -  shk_Unhook - used to terminate a single hooking session
'    -  shk_CallNextHook - enables the CallNextHookEx API function on hooked threads
'    -  zGet_lParamUser, zSet_lParamUser - returns/replaces the optional lParamUser set in ssc_Subclass & shk_SetHook
'   (-) can be removed if not needed. See their comments
'   all of above can be made public if so desired.
'   3. In your form/uc/class/ppg unload/terminate event, include the statement: shk_TerminateHooks or zTerminateThunks HookThunk
'   4. Include the generic hook procedure routine: myHookProc near bottom of this module
'   5. Include the following if they do not exist in your code already (also used in subclass section above):
'        Private Declare Function IsWindowUnicode Lib "user32.dll" (ByVal hwnd As Long) As Long
'        Private Const IDX_PARM_USER As Long = 13       'Thunk data index of the User-defined callback parameter data index
'        Private Enum eMsgWhen                          'When to callback
'          MSG_BEFORE = 1                               'Callback before the original WndProc/HookProc
'          MSG_AFTER = 2                                'Callback after the original WndProc/HookProc
'          MSG_BEFORE_AFTER = MSG_BEFORE Or MSG_AFTER   'Callback before and after the original WndProc/HookProc
'        End Enum
'   6. Also include the following declarations which do not exist in the common-use or subclassing sections
  
    '-SelfHook specific declarations----------------------------------------------------------------------------
    Private Declare Function SetWindowsHookExA Lib "user32" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hMod As Long, ByVal dwThreadId As Long) As Long
    Private Declare Function SetWindowsHookExW Lib "user32" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hMod As Long, ByVal dwThreadId As Long) As Long
    Private Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
    Private Declare Function CallNextHookEx Lib "user32.dll" (ByVal hHook As Long, ByVal nCode As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
    Private Declare Function GetDesktopWindow Lib "user32.dll" () As Long
    
    Private Enum eHookType  ' http://msdn2.microsoft.com/en-us/library/ms644990.aspx
      WH_MSGFILTER = -1
      WH_JOURNALRECORD = 0
      WH_JOURNALPLAYBACK = 1
      WH_KEYBOARD = 2
      WH_GETMESSAGE = 3
      WH_CALLWNDPROC = 4
      WH_CBT = 5
      WH_SYSMSGFILTER = 6
      WH_MOUSE = 7
      WH_DEBUG = 9
      WH_SHELL = 10
      WH_FOREGROUNDIDLE = 11
      WH_CALLWNDPROCRET = 12
      WH_KEYBOARD_LL = 13       ' NT/2000/XP+ only, Global hook only
      WH_MOUSE_LL = 14          ' NT/2000/XP+ only, Global hook only
    End Enum
'-------------------------------------------------------------------------------------------------
'========================================================================================================
' TO USE IDE-SAFE CALLBACKS...
'==============================
'   Special notes:
'    a. scb_SetCallbackAddr uses function ordinals. Last routine in the class/form/uc/ppg is Ordinal #1, second to last is Ordinal #2, etc
'           IMPORTANT: Routines used for callbacks MUST NOT be Public, can be Private or Friend
'    b. The callback function in your class/form/uc/ppg must be a Function that returns Long.
'       For example. The callback routine for a timer has no return value per MSDN, but when that timer
'       procedure is coded, the callback function must return a long. The return value is not important in that case
'    c. VB5 users. Search for zFnAddr("vba6", "EbMode") and replace with zFnAddr("vba5", "EbMode")
'    d. Do not terminate application while stopped in the callback procedure
'    e. Never call scb_ReleaseCallback from within the callback procedure
'    f. At a minimum, review scb_SetCallbackAddr, scb_ReleaseCallback & scb_TerminateCallbacks
'
'   1. Include all common-use items in above "common-use" section
'   2. Include the following routines:  scb_ = self-callback
'       scb_SetCallbackAddr - used the same as AddressOf for class/form/uc/ppg routines
'    -  scb_ReleaseCallback - used to release memory for a specific callback
'    -  scb_TerminateCallbacks - used to terminate all callback addresses (release allocated memory)
'  (-) can be removed if not needed. See their comments
'   all of above can be made public if so desired
'   3. In your form/uc/class unload/terminate event, include the statement: scb_TerminateCallbacks or zTerminateThunks CallbackThunk
'   4. No additional delcarations are required, all that are needed exist in the common-use section above                                                                                                 '
'
    '-SelfCallback specific declarations----------------------------------------------------------
    ' none
'-------------------------------------------------------------------------------------------------

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewColor As OLE_COLOR)
    UserControl.BackColor = NewColor
    If NewColor < 0 Then m_BackClr = GetSysColor(NewColor And &HFF&) Else m_BackClr = NewColor
    DeleteObject m_BackClrBrush
    m_BackClrBrush = CreateSolidBrush(m_BackClr)
    InvalidateRect m_hWnd, m_RC, -1&
End Property
Public Property Get BorderStyle() As UniTextBorderStyle
    BorderStyle = m_BorderStyle
End Property
Public Property Let BorderStyle(ByVal NewValue As UniTextBorderStyle)
    m_BorderStyle = NewValue
    UserControl_Resize
End Property
Public Property Get Font() As IFontDisp
    Set Font = UserControl.Font
End Property
Public Property Set Font(ByRef NewValue As IFontDisp)
    Set UserControl.Font = NewValue
    Private_InitFont
End Property
Public Property Get ForeColor() As OLE_COLOR
    ForeColor = m_ForeColor
End Property
Public Property Let ForeColor(ByVal NewValue As OLE_COLOR)
    m_ForeColor = NewValue
    If m_ForeColor < 0 Then m_ForeClr = GetSysColor(m_ForeColor And &HFF&) Else m_ForeClr = m_ForeColor
    InvalidateRect m_hWnd, m_RC, -1&
End Property
Public Property Get Locked() As Boolean
    Locked = m_Locked
End Property
Public Property Let Locked(ByVal NewValue As Boolean)
    If NewValue <> m_Locked Then m_Locked = NewValue: Private_Init
End Property
Public Function MouseOver() As Boolean
    MouseOver = m_MouseOver
End Function
Public Property Get MultiLine() As Boolean
    MultiLine = m_MultiLine
End Property
Public Property Let MultiLine(ByVal NewValue As Boolean)
    ' only change multiline if it has really changed
    If m_MultiLine <> NewValue Then m_MultiLine = NewValue: Private_Init
End Property
Public Property Get PasswordChar() As String
    PasswordChar = m_PasswordChar
End Property
Public Property Let PasswordChar(ByRef NewValue As String)
    If LenB(NewValue) = 0 Then
        If LenB(m_PasswordChar) Then
            m_PasswordChar = vbNullString
            Private_Init
        End If
    ElseIf m_PasswordChar <> NewValue Then
        If LenB(m_PasswordChar) = 0 Then
            m_PasswordChar = ChrW$(AscW(NewValue))
            Private_Init
        Else
            m_PasswordChar = ChrW$(AscW(NewValue))
            SendMessageW m_hWnd, EM_SETPASSWORDCHAR, AscW(m_PasswordChar), 0&
        End If
    End If
End Property
Public Property Get ScrollBars() As ScrollBarConstants
    ScrollBars = m_ScrollBars
End Property
Public Property Let ScrollBars(ByVal NewValue As ScrollBarConstants)
    ' only change if really changed
    If m_ScrollBars <> NewValue Then
        m_ScrollBars = NewValue
        Private_Init
    End If
End Property
Public Property Get Text() As String
Attribute Text.VB_UserMemId = 0
Attribute Text.VB_MemberFlags = "400"
    Dim lngLen As Long
    If m_hWnd <> 0 Then
        lngLen = SendMessageW(m_hWnd, WM_GETTEXTLENGTH, 0&, ByVal 0&) * 2 + 1
        If lngLen > 1 Then
            ReDim Preserve m_bytText(lngLen)
            lngLen = SendMessageW(m_hWnd, WM_GETTEXT, lngLen, ByVal VarPtr(m_bytText(0))) * 2 - 1
            If lngLen >= 0 Then
                ReDim Preserve m_bytText(lngLen)
                Text = m_bytText
            End If
        End If
    Else
        Text = m_Text
    End If
End Property
Public Property Let Text(ByRef NewValue As String)
    If m_hWnd <> 0 Then
        SendMessageW m_hWnd, WM_SETTEXT, 0&, ByVal StrPtr(NewValue)
    Else
        m_Text = NewValue
    End If
End Property
Public Property Get UseEvents() As Boolean
    UseEvents = m_UseEvents
End Property
Public Property Let UseEvents(ByVal NewValue As Boolean)
    m_UseEvents = NewValue
End Property
Private Sub UserControl_AmbientChanged(PropertyName As String)
    ' see if container scalemode has changed
    If LenB(PropertyName) = 20 Then If PropertyName = "ScaleUnits" Then m_ScaleMode = Private_GetContainerScaleMode
End Sub
Private Sub UserControl_EnterFocus()
    If m_hWnd Then m_HasFocus = True: SetFocus m_hWnd
End Sub
Private Sub UserControl_ExitFocus()
    If blnDesignTime Then PropertyChanged "Text"
End Sub
Private Sub UserControl_Initialize()
    If Not App.LogMode = 0 Then
        ' this will fix a problem with some versions of comctl32.dll when using XP Themes
        ' http://www.vbaccelerator.com/home/vb/Code/Libraries/XP_Visual_Styles/Preventing_Crashes_at_Shutdown/article.asp
        m_Shell32 = GetModuleHandleA("shell32.dll")
        If m_Shell32 = 0 Then m_Shell32 = LoadLibraryA("shell32.dll"): m_FreeShell32 = True
    End If
    ' see if mouse tracking is supported (WM_MOUSELEAVE)
    m_TrackUser32 = Private_IsFunctionSupported("TrackMouseEvent", "user32.dll")
    If Not m_TrackUser32 Then m_TrackComCtl = Private_IsFunctionSupported("_TrackMouseEvent", "comctl32.dll")
    ' set default settings
    m_MultiLine = False
    m_ScrollBars = vbSBNone
End Sub

Private Sub UserControl_InitProperties()
    ' design time?
    blnDesignTime = (Not UserControl.Ambient.UserMode)
    ' container scalemode
    m_ScaleMode = Private_GetContainerScaleMode
    ' default property values
    If UserControl.BackColor < 0 Then m_BackClr = GetSysColor(UserControl.BackColor And &HFF&) Else m_BackClr = UserControl.BackColor
    m_BackClrBrush = CreateSolidBrush(m_BackClr)
    m_BorderStyle = [3D]
    Set UserControl.Font = UserControl.Ambient.Font
    m_ForeColor = vbWindowText
    If m_ForeColor < 0 Then m_ForeClr = GetSysColor(m_ForeColor And &HFF&) Else m_ForeClr = m_ForeColor
    m_UseEvents = True
    ' subclass
    If ssc_Subclass(UserControl.hWnd, , 1, , Ambient.UserMode) Then
        ssc_AddMsg UserControl.hWnd, MSG_BEFORE, WM_COMMAND, WM_DESTROY, WM_ERASEBKGND, WM_CTLCOLOREDIT, WM_CTLCOLORSTATIC
        ssc_AddMsg UserControl.hWnd, MSG_AFTER, WM_COMMAND, WM_PAINT
        If m_TrackUser32 Or m_TrackComCtl Then ssc_AddMsg UserControl.hWnd, MSG_AFTER, WM_MOUSELEAVE
        Debug.Print UserControl.Ambient.DisplayName & ": Started subclassing! " & Hex$(UserControl.hWnd)
    Else
        Debug.Print UserControl.Ambient.DisplayName & ": Failed to subclass! " & Hex$(UserControl.hWnd)
    End If
    ' initial show
    Private_Init
    ' hook
    shk_SetHook WH_KEYBOARD, , MSG_BEFORE, , 3
    shk_SetHook WH_CALLWNDPROC, , MSG_AFTER, , 3
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    ' design time?
    blnDesignTime = (Not UserControl.Ambient.UserMode)
    ' container scalemode
    m_ScaleMode = Private_GetContainerScaleMode
    ' load property values
    UserControl.BackColor = PropBag.ReadProperty("BackColor", vbWindowBackground)
    If UserControl.BackColor < 0 Then m_BackClr = GetSysColor(UserControl.BackColor And &HFF&) Else m_BackClr = UserControl.BackColor
    m_BackClrBrush = CreateSolidBrush(m_BackClr)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", [3D])
    Set UserControl.Font = PropBag.ReadProperty("Font", UserControl.Ambient.Font)
    m_ForeColor = PropBag.ReadProperty("ForeColor", vbWindowText)
    If m_ForeColor < 0 Then m_ForeClr = GetSysColor(m_ForeColor And &HFF&) Else m_ForeClr = m_ForeColor
    m_Locked = PropBag.ReadProperty("Locked", False)
    m_MultiLine = PropBag.ReadProperty("MultiLine", False)
    m_PasswordChar = PropBag.ReadProperty("PasswordChar", vbNullString)
    m_ScrollBars = PropBag.ReadProperty("ScrollBars", vbSBNone)
    m_Text = Private_UTF8toUTF16(StrConv(PropBag.ReadProperty("Text", vbNullString), vbFromUnicode))
    m_UseEvents = PropBag.ReadProperty("UseEvents", True)
    ' subclass
    If ssc_Subclass(UserControl.hWnd, , 1, , Ambient.UserMode) Then
        ssc_AddMsg UserControl.hWnd, MSG_BEFORE, WM_COMMAND, WM_DESTROY, WM_ERASEBKGND, WM_CTLCOLOREDIT, WM_CTLCOLORSTATIC
        ssc_AddMsg UserControl.hWnd, MSG_AFTER, WM_COMMAND, WM_PAINT
        If m_TrackUser32 Or m_TrackComCtl Then ssc_AddMsg UserControl.hWnd, MSG_AFTER, WM_MOUSELEAVE
        Debug.Print UserControl.Ambient.DisplayName & ": Started subclassing! " & Hex$(UserControl.hWnd)
    Else
        Debug.Print UserControl.Ambient.DisplayName & ": Failed to subclass! " & Hex$(UserControl.hWnd)
    End If
    ' initial show
    Private_Init
    ' hook
    shk_SetHook WH_KEYBOARD, , MSG_BEFORE, , 3
    shk_SetHook WH_CALLWNDPROC, , MSG_AFTER, , 3
End Sub

Private Sub UserControl_Resize()
    ' update rectangle
    m_RC.Right = UserControl.ScaleWidth
    m_RC.Bottom = UserControl.ScaleHeight
    ' exit if missing
    If m_hWnd = 0 Then Exit Sub
    ' borderstyle value tells us how deep we go...
    MoveWindow m_hWnd, m_BorderStyle, m_BorderStyle, m_RC.Right - m_BorderStyle * 2, m_RC.Bottom - m_BorderStyle * 2, -1&
End Sub

Private Sub UserControl_Terminate()
    shk_UnHook WH_KEYBOARD
    shk_UnHook WH_CALLWNDPROC
    ' remove font
    If m_hFnt <> 0 Then DeleteObject m_hFnt
    ' remove forecolor
    If m_BackClrBrush <> 0 Then DeleteObject m_BackClrBrush
    ' remove textbox
    If m_hWnd <> 0 Then DestroyWindow m_hWnd
    ' unload shell32 if it was loaded by this control
    If m_FreeShell32 Then FreeLibrary m_Shell32
    ' final kills
    'ssc_Terminate
    'shk_TerminateHooks
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    ' save settings
    PropBag.WriteProperty "BackColor", UserControl.BackColor
    PropBag.WriteProperty "BorderStyle", m_BorderStyle
    PropBag.WriteProperty "Font", UserControl.Font
    PropBag.WriteProperty "ForeColor", m_ForeColor
    PropBag.WriteProperty "Locked", m_Locked
    PropBag.WriteProperty "MultiLine", m_MultiLine
    PropBag.WriteProperty "PasswordChar", m_PasswordChar
    PropBag.WriteProperty "ScrollBars", m_ScrollBars
    PropBag.WriteProperty "Text", StrConv(Private_UTF16toUTF8(Me.Text), vbUnicode)
    PropBag.WriteProperty "UseEvents", m_UseEvents
End Sub

'-SelfSub code------------------------------------------------------------------------------------
'-The following routines are exclusively for the ssc_Subclass routines----------------------------
Private Function ssc_Subclass(ByVal lng_hWnd As Long, _
                    Optional ByVal lParamUser As Long = 0, _
                    Optional ByVal nOrdinal As Long = 1, _
                    Optional ByVal oCallback As Object = Nothing, _
                    Optional ByVal bIdeSafety As Boolean = True, _
                    Optional ByRef bUnicode As Boolean = False, _
                    Optional ByVal bIsAPIwindow As Boolean = False) As Boolean 'Subclass the specified window handle

    '*************************************************************************************************
    '* lng_hWnd   - Handle of the window to subclass
    '* lParamUser - Optional, user-defined callback parameter
    '* nOrdinal   - Optional, ordinal index of the callback procedure. 1 = last private method, 2 = second last private method, etc.
    '* oCallback  - Optional, the object that will receive the callback. If undefined, callbacks are sent to this object's instance
    '* bIdeSafety - Optional, enable/disable IDE safety measures. There is not reason to set this to False
    '* bUnicode - Optional, if True, Unicode API calls should be made to the window vs ANSI calls
    '*            Parameter is byRef and its return value should be checked to know if ANSI to be used or not
    '* bIsAPIwindow - Optional, if True DestroyWindow will be called if IDE ENDs
    '*****************************************************************************************
    '** Subclass.asm - subclassing thunk
    '**
    '** Paul_Caton@hotmail.com
    '** Copyright free, use and abuse as you see fit.
    '**
    '** v2.0 Re-write by LaVolpe, based mostly on Paul Caton's original thunks....... 20070720
    '** .... Reorganized & provided following additional logic
    '** ....... Unsubclassing only occurs after thunk is no longer recursed
    '** ....... Flag used to bypass callbacks until unsubclassing can occur
    '** ....... Timer used as delay mechanism to free thunk memory afer unsubclassing occurs
    '** .............. Prevents crash when one window subclassed multiple times
    '** .............. More END safe, even if END occurs within the subclass procedure
    '** ....... Added ability to destroy API windows when IDE terminates
    '** ....... Added auto-unsubclass when WM_NCDESTROY received
    '*****************************************************************************************
    ' Subclassing procedure must be declared identical to the one at the end of this class (Sample at Ordinal #1)

    Dim z_Sc(0 To IDX_UNICODE) As Long                 'Thunk machine-code initialised here
    
    Const SUB_NAME      As String = "ssc_Subclass"     'This routine's name
    Const CODE_LEN      As Long = 4 * IDX_UNICODE + 4  'Thunk length in bytes
    Const PAGE_RWX      As Long = &H40&                'Allocate executable memory
    Const MEM_COMMIT    As Long = &H1000&              'Commit allocated memory
    Const MEM_RELEASE   As Long = &H8000&              'Release allocated memory flag
    Const GWL_WNDPROC   As Long = -4                   'SetWindowsLong WndProc index
    Const WNDPROC_OFF   As Long = &H60                 'Thunk offset to the WndProc execution address
    Const MEM_LEN       As Long = CODE_LEN + (8 * (MSG_ENTRIES + 1)) 'Bytes to allocate per thunk, data + code + msg tables
    
  ' This is the complete listing of thunk offset values and what they point/relate to.
  ' Those rem'd out are used elsewhere or are initialized in Declarations section
  
  'Const IDX_RECURSION  As Long = 0     'Thunk data index of callback recursion count
  'Const IDX_SHUTDOWN   As Long = 1     'Thunk data index of the termination flag
  'Const IDX_INDEX      As Long = 2     'Thunk data index of the subclassed hWnd
   Const IDX_EBMODE     As Long = 3     'Thunk data index of the EbMode function address
   Const IDX_CWP        As Long = 4     'Thunk data index of the CallWindowProc function address
   Const IDX_SWL        As Long = 5     'Thunk data index of the SetWindowsLong function address
   Const IDX_FREE       As Long = 6     'Thunk data index of the VirtualFree function address
   Const IDX_BADPTR     As Long = 7     'Thunk data index of the IsBadCodePtr function address
   Const IDX_OWNER      As Long = 8     'Thunk data index of the Owner object's vTable address
  'Const IDX_PREVPROC   As Long = 9     'Thunk data index of the original WndProc
   Const IDX_CALLBACK   As Long = 10    'Thunk data index of the callback method address
  'Const IDX_BTABLE     As Long = 11    'Thunk data index of the Before table
  'Const IDX_ATABLE     As Long = 12    'Thunk data index of the After table
  'Const IDX_PARM_USER  As Long = 13    'Thunk data index of the User-defined callback parameter data index
   Const IDX_DW         As Long = 14    'Thunk data index of the DestroyWinodw function address
   Const IDX_ST         As Long = 15    'Thunk data index of the SetTimer function address
   Const IDX_KT         As Long = 16    'Thunk data index of the KillTimer function address
   Const IDX_EBX_TMR    As Long = 20    'Thunk code patch index of the thunk data for the delay timer
   Const IDX_EBX        As Long = 26    'Thunk code patch index of the thunk data
  'Const IDX_UNICODE    As Long = xx    'Must be UBound(subclass thunkdata)+1; index for unicode support
    
    Dim z_ScMem       As Long           'Thunk base address
    Dim nAddr         As Long
    Dim nID           As Long
    Dim nMyID         As Long
    Dim bIDE          As Boolean

    If IsWindow(lng_hWnd) = 0 Then      'Ensure the window handle is valid
        zError SUB_NAME, "Invalid window handle"
        Exit Function
    End If
    
    nMyID = GetCurrentProcessId                         'Get this process's ID
    GetWindowThreadProcessId lng_hWnd, nID              'Get the process ID associated with the window handle
    If nID <> nMyID Then                                'Ensure that the window handle doesn't belong to another process
        zError SUB_NAME, "Window handle belongs to another process"
        Exit Function
    End If
    
    If oCallback Is Nothing Then Set oCallback = Me     'If the user hasn't specified the callback owner
    
    nAddr = zAddressOf(oCallback, nOrdinal)             'Get the address of the specified ordinal method
    If nAddr = 0 Then                                   'Ensure that we've found the ordinal method
        zError SUB_NAME, "Callback method not found"
        Exit Function
    End If
        
    z_ScMem = VirtualAlloc(0, MEM_LEN, MEM_COMMIT, PAGE_RWX) 'Allocate executable memory
    
    If z_ScMem <> 0 Then                                  'Ensure the allocation succeeded
    
      If z_scFunk Is Nothing Then Set z_scFunk = New Collection 'If this is the first time through, do the one-time initialization
      On Error GoTo CatchDoubleSub                              'Catch double subclassing
        z_scFunk.Add z_ScMem, "h" & lng_hWnd                    'Add the hWnd/thunk-address to the collection
      On Error GoTo 0
      
   'z_Sc (0) thru z_Sc(17) are used as storage for the thunks & IDX_ constants above relate to these thunk positions which are filled in below
    z_Sc(18) = &HD231C031: z_Sc(19) = &HBBE58960: z_Sc(21) = &H21E8F631: z_Sc(22) = &HE9000001: z_Sc(23) = &H12C&: z_Sc(24) = &HD231C031: z_Sc(25) = &HBBE58960: z_Sc(27) = &H3FFF631: z_Sc(28) = &H75047339: z_Sc(29) = &H2873FF23: z_Sc(30) = &H751C53FF: z_Sc(31) = &HC433913: z_Sc(32) = &H53FF2274: z_Sc(33) = &H13D0C: z_Sc(34) = &H18740000: z_Sc(35) = &H875C085: z_Sc(36) = &H820443C7: z_Sc(37) = &H90000000: z_Sc(38) = &H87E8&: z_Sc(39) = &H22E900: z_Sc(40) = &H90900000: z_Sc(41) = &H2C7B8B4A: z_Sc(42) = &HE81C7589: z_Sc(43) = &H90&: z_Sc(44) = &H75147539: z_Sc(45) = &H6AE80F: z_Sc(46) = &HD2310000: z_Sc(47) = &HE8307B8B: z_Sc(48) = &H7C&: z_Sc(49) = &H7D810BFF: z_Sc(50) = &H8228&: z_Sc(51) = &HC7097500: z_Sc(52) = &H80000443: z_Sc(53) = &H90900000: z_Sc(54) = &H44753339: z_Sc(55) = &H74047339: z_Sc(56) = &H2473FF3F: z_Sc(57) = &HFFFFFC68
    z_Sc(58) = &H2475FFFF: z_Sc(59) = &H811453FF: z_Sc(60) = &H82047B: z_Sc(61) = &HC750000: z_Sc(62) = &H74387339: z_Sc(63) = &H2475FF07: z_Sc(64) = &H903853FF: z_Sc(65) = &H81445B89: z_Sc(66) = &H484443: z_Sc(67) = &H73FF0000: z_Sc(68) = &H646844: z_Sc(69) = &H56560000: z_Sc(70) = &H893C53FF: z_Sc(71) = &H90904443: z_Sc(72) = &H10C261: z_Sc(73) = &H53E8&: z_Sc(74) = &H3075FF00: z_Sc(75) = &HFF2C75FF: z_Sc(76) = &H75FF2875: z_Sc(77) = &H2473FF24: z_Sc(78) = &H891053FF: z_Sc(79) = &H90C31C45: z_Sc(80) = &H34E30F8B: z_Sc(81) = &H1078C985: z_Sc(82) = &H4C781: z_Sc(83) = &H458B0000: z_Sc(84) = &H75AFF228: z_Sc(85) = &H90909023: z_Sc(86) = &H8D144D8D: z_Sc(87) = &H8D503443: z_Sc(88) = &H75FF1C45: z_Sc(89) = &H2C75FF30: z_Sc(90) = &HFF2875FF: z_Sc(91) = &H51502475: z_Sc(92) = &H2073FF52: z_Sc(93) = &H902853FF: z_Sc(94) = &H909090C3: z_Sc(95) = &H74447339: z_Sc(96) = &H4473FFF7
    z_Sc(97) = &H4053FF56: z_Sc(98) = &HC3447389: z_Sc(99) = &H89285D89: z_Sc(100) = &H45C72C75: z_Sc(101) = &H800030: z_Sc(102) = &H20458B00: z_Sc(103) = &H89145D89: z_Sc(104) = &H81612445: z_Sc(105) = &H4C4&: z_Sc(106) = &H1862FF00

    ' cache callback related pointers & offsets
      z_Sc(IDX_EBX) = z_ScMem                                                 'Patch the thunk data address
      z_Sc(IDX_EBX_TMR) = z_ScMem                                             'Patch the thunk data address
      z_Sc(IDX_INDEX) = lng_hWnd                                              'Store the window handle in the thunk data
      z_Sc(IDX_BTABLE) = z_ScMem + CODE_LEN                                   'Store the address of the before table in the thunk data
      z_Sc(IDX_ATABLE) = z_ScMem + CODE_LEN + ((MSG_ENTRIES + 1) * 4)         'Store the address of the after table in the thunk data
      z_Sc(IDX_OWNER) = ObjPtr(oCallback)                                     'Store the callback owner's object address in the thunk data
      z_Sc(IDX_CALLBACK) = nAddr                                              'Store the callback address in the thunk data
      z_Sc(IDX_PARM_USER) = lParamUser                                        'Store the lParamUser callback parameter in the thunk data
      
      ' validate unicode request & cache unicode usage
      If bUnicode Then bUnicode = (IsWindowUnicode(lng_hWnd) <> 0&)
      z_Sc(IDX_UNICODE) = bUnicode                                            'Store whether the window is using unicode calls or not
      
      ' get function pointers for the thunk
      If bIdeSafety = True Then                                               'If the user wants IDE protection
          Debug.Assert zInIDE(bIDE)
          If bIDE = True Then z_Sc(IDX_EBMODE) = zFnAddr("vba6", "EbMode", bUnicode) 'Store the EbMode function address in the thunk data
                                                        '^^ vb5 users, change vba6 to vba5
      End If
      If bIsAPIwindow Then                                                    'If user wants DestroyWindow sent should IDE end
          z_Sc(IDX_DW) = zFnAddr("user32", "DestroyWindow", bUnicode)
      End If
      z_Sc(IDX_FREE) = zFnAddr("kernel32", "VirtualFree", bUnicode)           'Store the VirtualFree function address in the thunk data
      z_Sc(IDX_BADPTR) = zFnAddr("kernel32", "IsBadCodePtr", bUnicode)        'Store the IsBadCodePtr function address in the thunk data
      z_Sc(IDX_ST) = zFnAddr("user32", "SetTimer", bUnicode)                  'Store the SetTimer function address in the thunk data
      z_Sc(IDX_KT) = zFnAddr("user32", "KillTimer", bUnicode)                 'Store the KillTimer function address in the thunk data
      
      If bUnicode Then
          z_Sc(IDX_CWP) = zFnAddr("user32", "CallWindowProcW", bUnicode)      'Store CallWindowProc function address in the thunk data
          z_Sc(IDX_SWL) = zFnAddr("user32", "SetWindowLongW", bUnicode)       'Store the SetWindowLong function address in the thunk data
          RtlMoveMemory z_ScMem, VarPtr(z_Sc(0)), CODE_LEN                    'Copy the thunk code/data to the allocated memory
          z_Sc(IDX_PREVPROC) = SetWindowLongW(lng_hWnd, GWL_WNDPROC, z_ScMem + WNDPROC_OFF) 'Set the new WndProc, return the address of the original WndProc
      Else
          z_Sc(IDX_CWP) = zFnAddr("user32", "CallWindowProcA", bUnicode)      'Store CallWindowProc function address in the thunk data
          z_Sc(IDX_SWL) = zFnAddr("user32", "SetWindowLongA", bUnicode)       'Store the SetWindowLong function address in the thunk data
          RtlMoveMemory z_ScMem, VarPtr(z_Sc(0)), CODE_LEN                    'Copy the thunk code/data to the allocated memory
          z_Sc(IDX_PREVPROC) = SetWindowLongA(lng_hWnd, GWL_WNDPROC, z_ScMem + WNDPROC_OFF) 'Set the new WndProc, return the address of the original WndProc
      End If
      If z_Sc(IDX_PREVPROC) = 0 Then                                          'Ensure the new WndProc was set correctly
          zError SUB_NAME, "SetWindowLong failed, error #" & Err.LastDllError
          GoTo ReleaseMemory
      End If
      'Store the original WndProc address in the thunk data
      RtlMoveMemory z_ScMem + IDX_PREVPROC * 4, VarPtr(z_Sc(IDX_PREVPROC)), 4&
      ssc_Subclass = True                                                     'Indicate success
      
    Else
        zError SUB_NAME, "VirtualAlloc failed, error: " & Err.LastDllError
        
    End If

 Exit Function                                                                'Exit ssc_Subclass
    
CatchDoubleSub:
 zError SUB_NAME, "Window handle is already subclassed"
      
ReleaseMemory:
      VirtualFree z_ScMem, 0, MEM_RELEASE                                     'ssc_Subclass has failed after memory allocation, so release the memory
      
End Function

'Terminate all subclassing
Private Sub ssc_Terminate()
    ' can be made public, can be removed & zTerminateThunks can be called instead
    zTerminateThunks SubclassThunk
End Sub

'UnSubclass the specified window handle
Private Sub ssc_UnSubclass(ByVal lng_hWnd As Long)
    ' can be made public, can be removed & zUnthunk can be called instead
    zUnThunk lng_hWnd, SubclassThunk
End Sub

'Add the message value to the window handle's specified callback table
Private Sub ssc_AddMsg(ByVal lng_hWnd As Long, ByVal When As eMsgWhen, ParamArray Messages() As Variant)
    
    Dim z_ScMem       As Long                                   'Thunk base address
    
    z_ScMem = zMap_VFunction(lng_hWnd, SubclassThunk)           'Ensure that the thunk hasn't already released its memory
    If z_ScMem Then
      Dim M As Long
      For M = LBound(Messages) To UBound(Messages)
        Select Case VarType(Messages(M))                        ' ensure no strings, arrays, doubles, objects, etc are passed
        Case vbByte, vbInteger, vbLong
            If When And MSG_BEFORE Then                         'If the message is to be added to the before original WndProc table...
              If zAddMsg(Messages(M), IDX_BTABLE, z_ScMem) = False Then 'Add the message to the before table
                When = (When And Not MSG_BEFORE)
              End If
            End If
            If When And MSG_AFTER Then                          'If message is to be added to the after original WndProc table...
              If zAddMsg(Messages(M), IDX_ATABLE, z_ScMem) = False Then 'Add the message to the after table
                When = (When And Not MSG_AFTER)
              End If
            End If
        End Select
      Next
    End If
End Sub

'Delete the message value from the window handle's specified callback table
Private Sub ssc_DelMsg(ByVal lng_hWnd As Long, ByVal When As eMsgWhen, ParamArray Messages() As Variant)
    
    Dim z_ScMem       As Long                                                   'Thunk base address
    
    z_ScMem = zMap_VFunction(lng_hWnd, SubclassThunk)                           'Ensure that the thunk hasn't already released its memory
    If z_ScMem Then
      Dim M As Long
      For M = LBound(Messages) To UBound(Messages)                              ' ensure no strings, arrays, doubles, objects, etc are passed
        Select Case VarType(Messages(M))
        Case vbByte, vbInteger, vbLong
            If When And MSG_BEFORE Then                                         'If the message is to be removed from the before original WndProc table...
              zDelMsg Messages(M), IDX_BTABLE, z_ScMem                          'Remove the message to the before table
            End If
            If When And MSG_AFTER Then                                          'If message is to be removed from the after original WndProc table...
              zDelMsg Messages(M), IDX_ATABLE, z_ScMem                          'Remove the message to the after table
            End If
        End Select
      Next
    End If
End Sub

'Call the original WndProc
Private Function ssc_CallOrigWndProc(ByVal lng_hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    ' can be made public, can be removed if you will not use this in your window procedure
    Dim z_ScMem       As Long                           'Thunk base address
    z_ScMem = zMap_VFunction(lng_hWnd, SubclassThunk)
    If z_ScMem Then                                     'Ensure that the thunk hasn't already released its memory
        If zData(IDX_UNICODE, z_ScMem) Then
            ssc_CallOrigWndProc = CallWindowProcW(zData(IDX_PREVPROC, z_ScMem), lng_hWnd, uMsg, wParam, lParam) 'Call the original WndProc of the passed window handle parameter
        Else
            ssc_CallOrigWndProc = CallWindowProcA(zData(IDX_PREVPROC, z_ScMem), lng_hWnd, uMsg, wParam, lParam) 'Call the original WndProc of the passed window handle parameter
        End If
    End If
End Function

'Get the subclasser lParamUser callback parameter
Private Function zGet_lParamUser(ByVal hWnd_Hook_ID As Long, ByVal vType As eThunkType) As Long
    ' can be removed if you never will retrieve or replace the user-defined parameter
    If vType <> CallbackThunk Then
        Dim z_ScMem       As Long                                       'Thunk base address
        z_ScMem = zMap_VFunction(hWnd_Hook_ID, vType)
        If z_ScMem Then                                                 'Ensure that the thunk hasn't already released its memory
          zGet_lParamUser = zData(IDX_PARM_USER, z_ScMem)               'Get the lParamUser callback parameter
        End If
    End If
End Function

'Let the subclasser lParamUser callback parameter
Private Sub zSet_lParamUser(ByVal hWnd_Hook_ID As Long, ByVal vType As eThunkType, ByVal NewValue As Long)
    ' can be removed if you never will retrieve or replace the user-defined parameter
    If vType <> CallbackThunk Then
        Dim z_ScMem       As Long                                       'Thunk base address
        z_ScMem = zMap_VFunction(hWnd_Hook_ID, vType)
        If z_ScMem Then                                                 'Ensure that the thunk hasn't already released its memory
          zData(IDX_PARM_USER, z_ScMem) = NewValue                      'Set the lParamUser callback parameter
        End If
    End If
End Sub

'Add the message to the specified table of the window handle
Private Function zAddMsg(ByVal uMsg As Long, ByVal nTable As Long, ByVal z_ScMem As Long) As Boolean
      Dim nCount As Long                                                        'Table entry count
      Dim nBase  As Long
      Dim i      As Long                                                        'Loop index
    
      zAddMsg = True
      nBase = zData(nTable, z_ScMem)                                            'Map zData() to the specified table
      
      If uMsg = ALL_MESSAGES Then                                               'If ALL_MESSAGES are being added to the table...
        nCount = ALL_MESSAGES                                                   'Set the table entry count to ALL_MESSAGES
      Else
        
        nCount = zData(0, nBase)                                                'Get the current table entry count
        For i = 1 To nCount                                                     'Loop through the table entries
          If zData(i, nBase) = 0 Then                                           'If the element is free...
            zData(i, nBase) = uMsg                                              'Use this element
            GoTo Bail                                                           'Bail
          ElseIf zData(i, nBase) = uMsg Then                                    'If the message is already in the table...
            GoTo Bail                                                           'Bail
          End If
        Next i                                                                  'Next message table entry
    
        nCount = i                                                             'On drop through: i = nCount + 1, the new table entry count
        If nCount > MSG_ENTRIES Then                                           'Check for message table overflow
          zError "zAddMsg", "Message table overflow. Either increase the value of Const MSG_ENTRIES or use ALL_MESSAGES instead of specific message values"
          zAddMsg = False
          GoTo Bail
        End If
        
        zData(nCount, nBase) = uMsg                                            'Store the message in the appended table entry
      End If
    
      zData(0, nBase) = nCount                                                 'Store the new table entry count
Bail:
End Function

'Delete the message from the specified table of the window handle
Private Sub zDelMsg(ByVal uMsg As Long, ByVal nTable As Long, ByVal z_ScMem As Long)
      Dim nCount As Long                                                        'Table entry count
      Dim nBase  As Long
      Dim i      As Long                                                        'Loop index
    
      nBase = zData(nTable, z_ScMem)                                            'Map zData() to the specified table
    
      If uMsg = ALL_MESSAGES Then                                               'If ALL_MESSAGES are being deleted from the table...
        zData(0, nBase) = 0                                                     'Zero the table entry count
      Else
        nCount = zData(0, nBase)                                                'Get the table entry count
        
        For i = 1 To nCount                                                     'Loop through the table entries
          If zData(i, nBase) = uMsg Then                                        'If the message is found...
            zData(i, nBase) = 0                                                 'Null the msg value -- also frees the element for re-use
            GoTo Bail                                                           'Bail
          End If
        Next i                                                                  'Next message table entry
        
       ' zError "zDelMsg", "Message &H" & Hex$(uMsg) & " not found in table"
      End If
Bail:
End Sub

'-SelfHook code------------------------------------------------------------------------------------
'-The following routines are exclusively for the shk_SetHook routines----------------------------
Private Function shk_SetHook(ByVal HookType As eHookType, _
                    Optional ByVal bGlobal As Boolean, _
                    Optional ByVal When As eMsgWhen = MSG_BEFORE, _
                    Optional ByVal lParamUser As Long = 0, _
                    Optional ByVal nOrdinal As Long = 1, _
                    Optional ByVal oCallback As Object = Nothing, _
                    Optional ByVal bIdeSafety As Boolean = True, _
                    Optional ByRef bUnicode As Boolean = False) As Boolean 'Setting specified hook

    '*************************************************************************************************
    '* HookType - One of the eHookType enumerators
    '* bGlobal - If False, then hook applies to app's thread else it applies Globally (only supported by WH_KEYBOARD_LL & WH_MOUSE_LL)
    '* When - either MSG_AFTER, MSG_BEFORE or MSG_BEFORE_AFTER
    '* lParamUser - Optional, user-defined callback parameter
    '* nOrdinal   - Optional, ordinal index of the callback procedure. 1 = last private method, 2 = second last private method, etc.
    '* oCallback  - Optional, the object that will receive the callback. If undefined, callbacks are sent to this object's instance
    '* bIdeSafety - Optional, enable/disable IDE safety measures. There is no reason to set this to false
    '* bUnicode - Optional, if True, Unicode API calls should be made to the window vs ANSI calls
    '*            Parameter is byRef and its return value should be checked to know if ANSI to be used or not
    '*************************************************************************************************
    ' Hook procedure must be declared identical to the one near the end of this class (Sample at Ordinal #2)

    ' \\LaVolpe - The ASM for this procedure rewritten to mirror Paul Caton's SelfSub ASM
    '       Therefore, it appears to be crash proof and allows a choice of whether you want
    '       hook messages before and/or after the VB gets the message
    
    Dim z_Sc(0 To 66) As Long                   'Thunk machine-code initialised here
    Const MEM_LEN      As Long = 4 * 67         'Thunk length in bytes (last # must be = UBound zSc() + 1)
    
    Const PAGE_RWX      As Long = &H40&         'Allocate executable memory
    Const MEM_COMMIT    As Long = &H1000&       'Commit allocated memory
    Const MEM_RELEASE   As Long = &H8000&       'Release allocated memory flag
    Const IDX_EBMODE    As Long = 3             'Thunk data index of the EbMode function address
    Const IDX_CNH       As Long = 4             'Thunk data index of the CallNextHook function address
    Const IDX_UNW       As Long = 5             'Thunk data index of the UnhookWindowsEx function address
    Const IDX_OBJCHK    As Long = 6             'Thunk data index of the callback validation token
    Const IDX_BADPTR    As Long = 7             'Thunk data index of the IsBadCodePtr function address
    Const IDX_OWNER     As Long = 8             'Thunk data index of the Owner object's vTable address
    Const IDX_CALLBACK  As Long = 10            'Thunk data index of the callback method address
    Const IDX_BTABLE    As Long = 11            'Thunk data index of the Before flag
    Const IDX_ATABLE    As Long = 12            'Thunk data index of the After flag
    Const IDX_EBX       As Long = 16            'Thunk code patch index of the thunk data
    Const PROC_OFF      As Long = &H38          'Thunk offset to the HookProc execution address
    Const SUB_NAME      As String = "shk_SetHook" 'This routine's name
    
    Dim nAddr           As Long
    Dim nID             As Long
    Dim nMyID           As Long
    Dim bIDE            As Boolean
    Dim z_ScMem         As Long                 'Thunk base address

    If oCallback Is Nothing Then Set oCallback = Me 'If the user hasn't specified the callback owner
      
    nAddr = zAddressOf(oCallback, nOrdinal)         'Get the address of the specified ordinal method
    If nAddr = 0 Then                               'Ensure that we've found the ordinal method
      zError SUB_NAME, "Callback method not found"
      Exit Function
    End If
       
    If Not bGlobal Then nID = App.ThreadID                      ' thread ID to be used if not global hook
      
    z_ScMem = VirtualAlloc(0, MEM_LEN, MEM_COMMIT, PAGE_RWX)    'Allocate executable memory
    
    If z_ScMem <> 0 Then                                        'Ensure the allocation succeeded
      
        If z_hkFunk Is Nothing Then Set z_hkFunk = New Collection   'If this is the first time through, do the one-time initialization
        On Error GoTo CatchDoubleSub                                'Catch double subclassing
          z_hkFunk.Add z_ScMem, "h" & HookType                      'Add the hook/thunk-address to the collection
        On Error GoTo 0
        
        ' create the thunk; zSc(16) filled in below along with z_Sc(2-13)
        z_Sc(14) = &HD231C031: z_Sc(15) = &HBBE58960: z_Sc(17) = &H3FFF631: z_Sc(18) = &H75047339: z_Sc(19) = &H2873FF2F: z_Sc(20) = &H751C53FF: z_Sc(21) = &HC43391F: z_Sc(22) = &H7B8B2E74: z_Sc(23) = &H8478B20: z_Sc(24) = &H75184339: z_Sc(25) = &HC53FF0F: z_Sc(26) = &H13D&: z_Sc(27) = &H85197400: z_Sc(28) = &H900975C0: z_Sc(29) = &H443C7: z_Sc(30) = &H90000080: z_Sc(31) = &H47E8&: z_Sc(32) = &H2AE900: z_Sc(33) = &H90900000: z_Sc(34) = &H742C7339: z_Sc(35) = &H75894A0F: z_Sc(36) = &H46E81C: z_Sc(37) = &H75390000: z_Sc(38) = &H90157514: z_Sc(39) = &H27E8&: z_Sc(40) = &H30733900: z_Sc(41) = &HD2310A74: z_Sc(42) = &H2FE8&: z_Sc(43) = &H90909000: z_Sc(44) = &H33390BFF: z_Sc(45) = &H73390E75: z_Sc(46) = &HFF097404: z_Sc(47) = &H53FF2473: z_Sc(48) = &H90909014: z_Sc(49) = &HCC261: z_Sc(50) = &HFF2C75FF: z_Sc(51) = &H75FF2875: z_Sc(52) = &H2473FF24
        z_Sc(53) = &H891053FF: z_Sc(54) = &H90C31C45: z_Sc(55) = &H2873FF52: z_Sc(56) = &H5A1C53FF: z_Sc(57) = &H438D2275: z_Sc(58) = &H144D8D34: z_Sc(59) = &H1C458D50: z_Sc(60) = &HFF0873FF: z_Sc(61) = &H75FF2C75: z_Sc(62) = &H2475FF28: z_Sc(63) = &HFF525150: z_Sc(64) = &H53FF2073: z_Sc(65) = &H90909028: z_Sc(66) = &HC3&

        z_Sc(IDX_EBX) = z_ScMem                         'Patch the thunk data address
        z_Sc(IDX_INDEX) = HookType                      'Store the hook type in the thunk data
        z_Sc(IDX_OWNER) = ObjPtr(oCallback)             'Store the callback owner's object address in the thunk data
        z_Sc(IDX_CALLBACK) = nAddr                      'Store the callback address in the thunk data
        z_Sc(IDX_PARM_USER) = lParamUser                'Store the lParamUser callback parameter in the thunk data
        
        ' get a piece of the oCallback to use as a validation token
        RtlMoveMemory VarPtr(z_Sc(IDX_OBJCHK)), z_Sc(IDX_OWNER) + 8&, 4&

        ' validate unicode request & cache unicode usage
        If bUnicode Then bUnicode = (IsWindowUnicode(GetDesktopWindow) <> 0&)
        
        z_Sc(IDX_BADPTR) = zFnAddr("kernel32", "IsBadCodePtr", bUnicode)    'Store the IsBadCodePtr function address in the thunk data
        z_Sc(IDX_CNH) = zFnAddr("user32", "CallNextHookEx", bUnicode)       'Store CallWindowProc function address in the thunk data
        z_Sc(IDX_UNW) = zFnAddr("user32", "UnhookWindowsHookEx", bUnicode)  'Store the SetWindowLong function address in the thunk data
        
        If bIdeSafety = True Then                                           'If the user wants IDE protection
            Debug.Assert zInIDE(bIDE)
            If bIDE = True Then z_Sc(IDX_EBMODE) = zFnAddr("vba6", "EbMode", bUnicode) 'Store the EbMode function address in the thunk data
        End If
        
        If (When And MSG_BEFORE) = MSG_BEFORE Then z_Sc(IDX_BTABLE) = 1     ' non-zero flag if Before messages desired
        If (When And MSG_AFTER) = MSG_AFTER Then z_Sc(IDX_ATABLE) = 1       ' non-zero flag if After messages desired
        
        RtlMoveMemory z_ScMem, VarPtr(z_Sc(0)), MEM_LEN                     'Copy the thunk code/data to the allocated memory
        'Set the new HookProc, return the address of the original HookProc
        If bUnicode Then
            z_Sc(IDX_PREVPROC) = SetWindowsHookExW(HookType, z_ScMem + PROC_OFF, App.hInstance, nID)
        Else
            z_Sc(IDX_PREVPROC) = SetWindowsHookExA(HookType, z_ScMem + PROC_OFF, App.hInstance, nID)
        End If
        
        If z_Sc(IDX_PREVPROC) = 0 Then                                              'Ensure the new HookProc was set correctly
          zError SUB_NAME, "SetWindowsHookEx failed, error #" & Err.LastDllError
          GoTo ReleaseMemory
        End If
        RtlMoveMemory z_ScMem + IDX_PREVPROC * 4, VarPtr(z_Sc(IDX_PREVPROC)), 4&    'Store the callback address
            
        shk_SetHook = True                                                          'Indicate success
      Else
        zError SUB_NAME, "VirtualAlloc failed, error: " & Err.LastDllError
      End If
      
      Exit Function
    
CatchDoubleSub:
      zError SUB_NAME, "Hook is already established"
      
ReleaseMemory:
      VirtualFree z_ScMem, 0, MEM_RELEASE                                     'shk_SetHook has failed after memory allocation, so release the memory
    
End Function

'Call the next hook proc
Private Function shk_CallNextHook(ByVal HookType As eHookType, ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    ' can be made public, can be removed if you will not use this in your hook procedure
    Dim z_ScMem       As Long                           'Thunk base address
    z_ScMem = zMap_VFunction(HookType, HookThunk)
    If z_ScMem Then                                     'Ensure that the thunk hasn't already released its memory
        shk_CallNextHook = CallNextHookEx(zData(IDX_PREVPROC, z_ScMem), nCode, wParam, lParam) 'Call the next hook proc
    End If
End Function

Private Function shk_UnHook(ByVal HookType As eHookType) As Boolean
    ' can be made public, can be removed & zUnThunk can be called instead
    zUnThunk HookType, HookThunk
End Function

Private Sub shk_TerminateHooks()
    ' can be made public, can be removed & zTerminateThunks can be called instead
    zTerminateThunks HookThunk
End Sub


'-SelfCallback code------------------------------------------------------------------------------------
'-The following routines are exclusively for the scb_SetCallbackAddr routines----------------------------
Private Function scb_SetCallbackAddr(ByVal nParamCount As Long, _
                     Optional ByVal nOrdinal As Long = 1, _
                     Optional ByVal oCallback As Object = Nothing, _
                     Optional ByVal bIdeSafety As Boolean = True, _
                     Optional ByVal bIsTimerCallback As Boolean) As Long   'Return the address of the specified callback thunk
    '*************************************************************************************************
    '* nParamCount  - The number of parameters that will callback
    '* nOrdinal     - Callback ordinal number, the final private method is ordinal 1, the second last is ordinal 2, etc...
    '* oCallback    - Optional, the object that will receive the callback. If undefined, callbacks are sent to this object's instance
    '* bIdeSafety   - Optional, set to false to disable IDE protection.
    '* bIsTimerCallback - optional, set to true for extra protection when used as a SetTimer callback
    '       If True, timer will be destroyed when IDE/app terminates. See scb_ReleaseCallback.
    '*************************************************************************************************
    ' Callback procedure must return a Long even if, per MSDN, the callback procedure is a Sub vs Function
    ' The number of parameters and their types are dependent on the individual callback procedures
    
    Const MEM_LEN     As Long = IDX_CALLBACKORDINAL * 4 + 4     'Memory bytes required for the callback thunk
    Const PAGE_RWX    As Long = &H40&                           'Allocate executable memory
    Const MEM_COMMIT  As Long = &H1000&                         'Commit allocated memory
    Const SUB_NAME      As String = "scb_SetCallbackAddr"       'This routine's name
    Const INDX_OWNER    As Long = 0                             'Thunk data index of the Owner object's vTable address
    Const INDX_CALLBACK As Long = 1                             'Thunk data index of the EbMode function address
    Const INDX_EBMODE   As Long = 2                             'Thunk data index of the IsBadCodePtr function address
    Const INDX_BADPTR   As Long = 3                             'Thunk data index of the IsBadCodePtr function address
    Const INDX_KT       As Long = 4                             'Thunk data index of the KillTimer function address
    Const INDX_EBX      As Long = 6                             'Thunk code patch index of the thunk data
    Const INDX_PARAMS   As Long = 18                            'Thunk code patch index of the number of parameters expected in callback
    Const INDX_PARAMLEN As Long = 24                            'Thunk code patch index of the bytes to be released after callback
    Const PROC_OFF      As Long = &H14                          'Thunk offset to the callback execution address

    Dim z_ScMem       As Long                                   'Thunk base address
    Dim z_Cb()    As Long                                       'Callback thunk array
    Dim nValue    As Long
    Dim nCallback As Long
    Dim bIDE      As Boolean
      
    If oCallback Is Nothing Then Set oCallback = Me     'If the user hasn't specified the callback owner
    If z_cbFunk Is Nothing Then
        Set z_cbFunk = New Collection           'If this is the first time through, do the one-time initialization
    Else
        On Error Resume Next                    'Catch already initialized?
        z_ScMem = z_cbFunk.Item("h" & ObjPtr(oCallback) & "." & nOrdinal) 'Test it
        If Err = 0 Then
            scb_SetCallbackAddr = z_ScMem + PROC_OFF  'we had this one, just reference it
            Exit Function
        End If
        On Error GoTo 0
    End If
    
    If nParamCount < 0 Then                     ' validate parameters
        zError SUB_NAME, "Invalid Parameter count"
        Exit Function
    End If
    
    nCallback = zAddressOf(oCallback, nOrdinal)         'Get the callback address of the specified ordinal
    If nCallback = 0 Then
        zError SUB_NAME, "Callback address not found."
        Exit Function
    End If
    z_ScMem = VirtualAlloc(0, MEM_LEN, MEM_COMMIT, PAGE_RWX) 'Allocate executable memory
        
    If z_ScMem = 0& Then
        zError SUB_NAME, "VirtualAlloc failed, error: " & Err.LastDllError  ' oops
        Exit Function
    End If
    z_cbFunk.Add z_ScMem, "h" & ObjPtr(oCallback) & "." & nOrdinal 'Add the callback/thunk-address to the collection
        
    ReDim z_Cb(0 To IDX_CALLBACKORDINAL) As Long          'Allocate for the machine-code array
    
    ' Create machine-code array
    z_Cb(5) = &HBB60E089: z_Cb(7) = &H73FFC589: z_Cb(8) = &HC53FF04: z_Cb(9) = &H59E80A74: z_Cb(10) = &HE9000000
    z_Cb(11) = &H30&: z_Cb(12) = &H87B81: z_Cb(13) = &H75000000: z_Cb(14) = &H9090902B: z_Cb(15) = &H42DE889: z_Cb(16) = &H50000000: z_Cb(17) = &HB9909090: z_Cb(19) = &H90900AE3
    z_Cb(20) = &H8D74FF: z_Cb(21) = &H9090FAE2: z_Cb(22) = &H53FF33FF: z_Cb(23) = &H90909004: z_Cb(24) = &H2BADC261: z_Cb(25) = &H3D0853FF: z_Cb(26) = &H1&: z_Cb(27) = &H23DCE74: z_Cb(28) = &H74000000: z_Cb(29) = &HAE807
    z_Cb(30) = &H90900000: z_Cb(31) = &H4589C031: z_Cb(32) = &H90DDEBFC: z_Cb(33) = &HFF0C75FF: z_Cb(34) = &H53FF0475: z_Cb(35) = &HC310&

    z_Cb(INDX_BADPTR) = zFnAddr("kernel32", "IsBadCodePtr", False)
    z_Cb(INDX_OWNER) = ObjPtr(oCallback)                  'Set the Owner
    z_Cb(INDX_CALLBACK) = nCallback                       'Set the callback address
    z_Cb(IDX_CALLBACKORDINAL) = nOrdinal                  'Cache ordinal used for zTerminateThunks
      
    If bIdeSafety = True Then                                           'If the user wants IDE protection
        Debug.Assert zInIDE(bIDE)
        If bIDE = True Then z_Cb(INDX_EBMODE) = zFnAddr("vba6", "EbMode", False) 'Store the EbMode function address in the thunk data
    End If
    If bIsTimerCallback Then
        z_Cb(INDX_KT) = zFnAddr("user32", "KillTimer", False)
    End If
        
    z_Cb(INDX_PARAMS) = nParamCount                         'Set the parameter count
    RtlMoveMemory VarPtr(z_Cb(INDX_PARAMLEN)) + 2, VarPtr(nParamCount * 4), 2&
      
    z_Cb(INDX_EBX) = z_ScMem                                'Set the data address relative to virtual memory pointer
      
    RtlMoveMemory z_ScMem, VarPtr(z_Cb(INDX_OWNER)), MEM_LEN 'Copy thunk code to executable memory
    scb_SetCallbackAddr = z_ScMem + PROC_OFF                       'Thunk code start address

End Function

Private Sub scb_ReleaseCallback(ByVal nOrdinal As Long, Optional ByVal oCallback As Object)
    ' can be made public, can be removed & zUnThunk can be called instead
    ' NEVER call this from within the callback routine itself
    
    ' oCallBack is the object containing nOrdinal to be released
    ' if oCallback was already closed (say it was a class or form), then you won't be
    '   able to release it here, but it will be released when zTerminateThunks is
    '   eventually called
    
    ' Special Warning. If the callback thunk is used for a recurring callback (i.e., Timer),
    ' then ensure you terminate what is using the callback before releasing the thunk,
    ' otherwise you are subject to a crash when that item tries to callback to zeroed memory
    zUnThunk nOrdinal, CallbackThunk, oCallback
End Sub

Private Sub scb_TerminateCallbacks()
    ' can be made public, can be removed & zTerminateThunks can be called instead
    zTerminateThunks CallbackThunk
End Sub


'-The following routines are used for each of the three types of thunks ----------------------------

'Maps zData() to the memory address for the specified thunk type
Private Function zMap_VFunction(vFuncTarget As Long, _
                                vType As eThunkType, _
                                Optional oCallback As Object, _
                                Optional bIgnoreErrors As Boolean) As Long
    
    Dim thunkCol As Collection
    Dim colID As String
    Dim z_ScMem       As Long         'Thunk base address
    
    If vType = CallbackThunk Then
        Set thunkCol = z_cbFunk
        If oCallback Is Nothing Then Set oCallback = Me
        colID = "h" & ObjPtr(oCallback) & "." & vFuncTarget
    ElseIf vType = HookThunk Then
        Set thunkCol = z_hkFunk
        colID = "h" & vFuncTarget
    ElseIf vType = SubclassThunk Then
        Set thunkCol = z_scFunk
        colID = "h" & vFuncTarget
    Else
        zError "zMap_Vfunction", "Invalid thunk type passed"
        Exit Function
    End If
    
    If thunkCol Is Nothing Then
        zError "zMap_VFunction", "Thunk hasn't been initialized"
    Else
        If thunkCol.Count Then
            On Error GoTo Catch
            z_ScMem = thunkCol(colID)               'Get the thunk address
            If IsBadCodePtr(z_ScMem) Then z_ScMem = 0&
            zMap_VFunction = z_ScMem
        End If
    End If
    Exit Function                                               'Exit returning the thunk address
    
Catch:
    ' error ignored when zUnThunk is called, error handled there
    If Not bIgnoreErrors Then zError "zMap_VFunction", "Thunk type for " & vType & " does not exist"
End Function

' sets/retrieves data at the specified offset for the specified memory address
Private Property Get zData(ByVal nIndex As Long, ByVal z_ScMem As Long) As Long
  RtlMoveMemory VarPtr(zData), z_ScMem + (nIndex * 4), 4
End Property

Private Property Let zData(ByVal nIndex As Long, ByVal z_ScMem As Long, ByVal nValue As Long)
  RtlMoveMemory z_ScMem + (nIndex * 4), VarPtr(nValue), 4
End Property

'Error handler
Private Sub zError(ByRef sRoutine As String, ByVal sMsg As String)
  ' Note. These two lines can be rem'd out if you so desire. But don't remove the routine
  App.LogEvent TypeName(Me) & "." & sRoutine & ": " & sMsg, vbLogEventTypeError
  MsgBox sMsg & ".", vbExclamation + vbApplicationModal, "Error in " & TypeName(Me) & "." & sRoutine
End Sub

'Return the address of the specified DLL/procedure
Private Function zFnAddr(ByVal sDLL As String, ByVal sProc As String, ByVal asUnicode As Boolean) As Long
  If asUnicode Then
    zFnAddr = GetProcAddress(GetModuleHandleW(StrPtr(sDLL)), sProc)         'Get the specified procedure address
  Else
    zFnAddr = GetProcAddress(GetModuleHandleA(sDLL), sProc)                 'Get the specified procedure address
  End If
  Debug.Assert zFnAddr                                                      'In the IDE, validate that the procedure address was located
  ' ^^ FYI VB5 users. Search for zFnAddr("vba6", "EbMode") and replace with zFnAddr("vba5", "EbMode")
End Function

'Return the address of the specified ordinal method on the oCallback object, 1 = last private method, 2 = second last private method, etc
Private Function zAddressOf(ByVal oCallback As Object, ByVal nOrdinal As Long) As Long
    ' Note: used both in subclassing and hooking routines
  Dim bSub  As Byte                                                         'Value we expect to find pointed at by a vTable method entry
  Dim bVal  As Byte
  Dim nAddr As Long                                                         'Address of the vTable
  Dim i     As Long                                                         'Loop index
  Dim J     As Long                                                         'Loop limit
  
  RtlMoveMemory VarPtr(nAddr), ObjPtr(oCallback), 4                         'Get the address of the callback object's instance
  If Not zProbe(nAddr + &H1C, i, bSub) Then                                 'Probe for a Class method
    If Not zProbe(nAddr + &H6F8, i, bSub) Then                              'Probe for a Form method
      If Not zProbe(nAddr + &H710, i, bSub) Then                            'Probe for a PropertyPage method
        If Not zProbe(nAddr + &H7A4, i, bSub) Then                          'Probe for a UserControl method
            Exit Function                                                   'Bail...
        End If
      End If
    End If
  End If
  
  i = i + 4                                                                 'Bump to the next entry
  J = i + 1024                                                              'Set a reasonable limit, scan 256 vTable entries
  Do While i < J
    RtlMoveMemory VarPtr(nAddr), i, 4                                       'Get the address stored in this vTable entry
    
    If IsBadCodePtr(nAddr) Then                                             'Is the entry an invalid code address?
      RtlMoveMemory VarPtr(zAddressOf), i - (nOrdinal * 4), 4               'Return the specified vTable entry address
      Exit Do                                                               'Bad method signature, quit loop
    End If

    RtlMoveMemory VarPtr(bVal), nAddr, 1                                    'Get the byte pointed to by the vTable entry
    If bVal <> bSub Then                                                    'If the byte doesn't match the expected value...
      RtlMoveMemory VarPtr(zAddressOf), i - (nOrdinal * 4), 4               'Return the specified vTable entry address
      Exit Do                                                               'Bad method signature, quit loop
    End If
    
    i = i + 4                                                               'Next vTable entry
  Loop
End Function

'Probe at the specified start address for a method signature
Private Function zProbe(ByVal nStart As Long, ByRef nMethod As Long, ByRef bSub As Byte) As Boolean
  Dim bVal    As Byte
  Dim nAddr   As Long
  Dim nLimit  As Long
  Dim nEntry  As Long
  
  nAddr = nStart                                                            'Start address
  nLimit = nAddr + 32                                                       'Probe eight entries
  Do While nAddr < nLimit                                                   'While we've not reached our probe depth
    RtlMoveMemory VarPtr(nEntry), nAddr, 4                                  'Get the vTable entry
    
    If nEntry <> 0 Then                                                     'If not an implemented interface
      RtlMoveMemory VarPtr(bVal), nEntry, 1                                 'Get the value pointed at by the vTable entry
      If bVal = &H33 Or bVal = &HE9 Then                                    'Check for a native or pcode method signature
        nMethod = nAddr                                                     'Store the vTable entry
        bSub = bVal                                                         'Store the found method signature
        zProbe = True                                                       'Indicate success
        Exit Do                                                             'Return
      End If
    End If
    
    nAddr = nAddr + 4                                                       'Next vTable entry
  Loop
End Function

Private Function zInIDE(ByRef bIDE As Boolean) As Boolean
    ' only called in IDE, never called when compiled
    bIDE = True
    zInIDE = bIDE
End Function

Private Sub zUnThunk(ByVal thunkID As Long, ByVal vType As eThunkType, Optional ByVal oCallback As Object)

    ' thunkID, depends on vType:
    '   - Subclassing:  the hWnd of the window subclassed
    '   - Hooking:      the hook type created
    '   - Callbacks:    the ordinal of the callback
    '       ensure KillTimer is already called, if any callback used for SetTimer
    ' oCallback only used when vType is CallbackThunk

    Const IDX_SHUTDOWN  As Long = 1
    Const MEM_RELEASE As Long = &H8000&             'Release allocated memory flag
    
    Dim z_ScMem       As Long                       'Thunk base address
    
    z_ScMem = zMap_VFunction(thunkID, vType, oCallback, True)
    Select Case vType
    Case SubclassThunk
        If z_ScMem Then                                 'Ensure that the thunk hasn't already released its memory
            zData(IDX_SHUTDOWN, z_ScMem) = 1            'Set the shutdown indicator
            zDelMsg ALL_MESSAGES, IDX_BTABLE, z_ScMem   'Delete all before messages
            zDelMsg ALL_MESSAGES, IDX_ATABLE, z_ScMem   'Delete all after messages
        End If
        If thunkID <> 0 Then z_scFunk.Remove "h" & thunkID                   'Remove the specified thunk from the collection
        
    Case HookThunk
        If z_ScMem Then                                 'Ensure that the thunk hasn't already released its memory
            ' if not unhooked, then unhook now
            If zData(IDX_SHUTDOWN, z_ScMem) = 0 Then UnhookWindowsHookEx zData(IDX_PREVPROC, z_ScMem)
            If zData(0, z_ScMem) = 0 Then               ' not recursing then
                VirtualFree z_ScMem, 0, MEM_RELEASE     'Release allocated memory
                z_hkFunk.Remove "h" & thunkID           'Remove the specified thunk from the collection
            Else
                zData(IDX_SHUTDOWN, z_ScMem) = 1        ' Set the shutdown indicator
                zData(IDX_ATABLE, z_ScMem) = 0          ' want no more After messages
                zData(IDX_BTABLE, z_ScMem) = 0          ' want no more Before messages
                ' when zTerminate is called this thunk's memory will be released
            End If
        Else
            z_hkFunk.Remove "h" & thunkID       'Remove the specified thunk from the collection
        End If
    Case CallbackThunk
        If z_ScMem Then                         'Ensure that the thunk hasn't already released its memory
            VirtualFree z_ScMem, 0, MEM_RELEASE 'Release allocated memory
        End If
        z_cbFunk.Remove "h" & ObjPtr(oCallback) & "." & thunkID           'Remove the specified thunk from the collection
    End Select

End Sub

Private Sub zTerminateThunks(ByVal vType As eThunkType)

    ' Terminates all thunks of a specific type
    ' Any subclassing, hooking, recurring callbacks should have already been canceled

    Dim i As Long
    Dim oCallback As Object
    Dim thunkCol As Collection
    Dim z_ScMem       As Long                           'Thunk base address
    Const INDX_OWNER As Long = 0
    
    Select Case vType
    Case SubclassThunk
        Set thunkCol = z_scFunk
    Case HookThunk
        Set thunkCol = z_hkFunk
    Case CallbackThunk
        Set thunkCol = z_cbFunk
    Case Else
        Exit Sub
    End Select
    
    If Not (thunkCol Is Nothing) Then                 'Ensure that hooking has been started
      With thunkCol
        For i = .Count To 1 Step -1                   'Loop through the collection of hook types in reverse order
          z_ScMem = .Item(i)                          'Get the thunk address
          If IsBadCodePtr(z_ScMem) = 0 Then           'Ensure that the thunk hasn't already released its memory
            Select Case vType
                Case SubclassThunk
                    zUnThunk zData(IDX_INDEX, z_ScMem), SubclassThunk    'Unsubclass
                Case HookThunk
                    zUnThunk zData(IDX_INDEX, z_ScMem), HookThunk        'Unhook
                Case CallbackThunk
                    ' zUnThunk expects object not pointer, convert pointer to object
                    RtlMoveMemory VarPtr(oCallback), VarPtr(zData(INDX_OWNER, z_ScMem)), 4&
                    zUnThunk zData(IDX_CALLBACKORDINAL, z_ScMem), CallbackThunk, oCallback ' release callback
                    ' remove the object pointer reference
                    RtlMoveMemory VarPtr(oCallback), VarPtr(INDX_OWNER), 4&
            End Select
          End If
        Next i                                        'Next member of the collection
      End With
      Set thunkCol = Nothing                         'Destroy the hook/thunk-address collection
    End If


End Sub


' EXAMPLE FUNCTIONS/CALLBACKS. Examples pulled from various postings

' ordinal #5 - Example of a window enumeration callback used with scb_SetCallbackAddr
' http://msdn2.microsoft.com/en-us/library/aa922950.aspx
Private Function myEnumWindowsProc(ByVal hWnd As Long, ByVal lParam As Long) As Long
    
'    Debug.Print hWnd
'    myEnumWindowsProc = 1 'Continue

End Function


' ordinal #4 - Example of font callback procedure used with scb_SetCallbackAddr
' http://msdn2.microsoft.com/en-us/library/Aa911409.aspx

' the LOGFONT and NEWTEXTMETRIC UDTs not declared in this template. Add this routine to a new class and unrem it for testing
'Private Function myEnumFontFamProc(lpNLF As LOGFONT, lpNTM As NEWTEXTMETRIC, ByVal FontType As Long, ByVal lParam As Long) As Long
'
'    ' Very cool; note that the call backs can receive UDTs too, just ensure they are ByRef and not ByVal
'    Dim FaceName As String
'
'    FaceName = StrConv(lpNLF.lfFaceName, vbUnicode)
'    FaceName = Left$(FaceName, InStr(FaceName, vbNullChar) - 1)
'    Debug.Print FaceName
'
'    myEnumFontFamProc = 1 'Continue
'
'End Function


' ordinal #3 - Example of a timer procedure callback used with scb_SetCallbackAddr
' http://msdn2.microsoft.com/en-us/library/ms644907.aspx
Private Function myTimerProc(ByVal hWnd As Long, ByVal tMsg As Long, ByVal TimerID As Long, ByVal tickCount As Long) As Long
    
    ' note: although a timer procedure, per MSDN, does not return a value,
    ' the function that is used for callbacks must return a value therefore
    ' all callback routines must be functions, even if the return value is not used
                        ' YOUR CODE HERE
                        
    ' Note that the scb_SetCallbackAddr has an optional parameter for timers created by
    ' SetTimer. Set that parameter to true to provide extra protection while in IDE.
    ' See scb_SetCallbackAddr & scb_ReleaseCallback

End Function

Private Function Private_GetContainerScaleMode() As ScaleModeConstants
    ' this should be called only when we know scalemode has changed
    Select Case UserControl.Ambient.ScaleUnits
        Case "Twip"
            Private_GetContainerScaleMode = vbTwips
        Case "Point"
            Private_GetContainerScaleMode = vbPoints
        Case "Pixel"
            Private_GetContainerScaleMode = vbPixels
        Case "Character"
            Private_GetContainerScaleMode = vbCharacters
        Case "Inch"
            Private_GetContainerScaleMode = vbInches
        Case "Millimeter"
            Private_GetContainerScaleMode = vbMillimeters
        Case "Centimeter"
            Private_GetContainerScaleMode = vbCentimeters
        Case "User"
            ' prevent user scalemode
            UserControl.Extender.Container.ScaleMode = vbTwips
            Private_GetContainerScaleMode = vbTwips
    End Select
End Function
Private Sub Private_Init()
    Dim lngStyle As Long
    ' remove old
    If m_hWnd <> 0 Then
        ssc_UnSubclass m_hWnd
        m_Text = Me.Text
        DestroyWindow m_hWnd
    End If
    ' init styles
    lngStyle = WS_CHILD Or WS_VISIBLE Or WS_TABSTOP Or ES_NOHIDESEL
    If m_MultiLine Then
        Select Case m_ScrollBars
            Case vbSBNone
                lngStyle = lngStyle Or ES_MULTILINE Or ES_WANTRETURN Or ES_AUTOVSCROLL Or ES_AUTOHSCROLL
            Case vbHorizontal
                lngStyle = lngStyle Or ES_MULTILINE Or ES_WANTRETURN Or ES_AUTOHSCROLL Or WS_HSCROLL
            Case vbVertical
                lngStyle = lngStyle Or ES_MULTILINE Or ES_WANTRETURN Or ES_AUTOVSCROLL Or WS_VSCROLL
            Case vbBoth
                lngStyle = lngStyle Or ES_MULTILINE Or ES_WANTRETURN Or ES_AUTOHSCROLL Or WS_HSCROLL Or WS_VSCROLL
        End Select
    Else
        lngStyle = lngStyle Or ES_AUTOHSCROLL
    End If
    If m_Locked Then lngStyle = lngStyle Or ES_READONLY
    If LenB(m_PasswordChar) Then lngStyle = lngStyle Or ES_PASSWORD
    
    ' create new textbox
    m_hWnd = CreateWindowExW(0&, StrPtr("Edit"), StrPtr(m_Text), _
        lngStyle, _
        m_BorderStyle, m_BorderStyle, m_RC.Right - m_BorderStyle * 2, m_RC.Bottom - m_BorderStyle * 2, _
        UserControl.hWnd, 0&, App.hInstance, 0&)
    SetWindowLong UserControl.hWnd, GWL_EXSTYLE, WS_CHILD Or WS_VISIBLE Or WS_TABSTOP Or ES_WANTRETURN
    ' get device context
    m_hDC = GetDC(m_hWnd)
    If LenB(m_PasswordChar) Then SendMessageW m_hWnd, EM_SETPASSWORDCHAR, AscW(m_PasswordChar), 0&
    ' setup font
    Private_InitFont
    ' start subclassing
    If ssc_Subclass(m_hWnd, , 2, , Not blnDesignTime, True) Then
        ssc_AddMsg m_hWnd, MSG_BEFORE, WM_CONTEXTMENU, WM_KEYDOWN, WM_KILLFOCUS, WM_SETFOCUS, WM_LBUTTONDOWN, WM_MBUTTONDOWN, WM_RBUTTONDOWN
        ssc_AddMsg m_hWnd, MSG_AFTER, WM_KEYUP, WM_MOUSELEAVE, WM_MOUSEMOVE, WM_LBUTTONUP, WM_MBUTTONUP, WM_RBUTTONUP, WM_LBUTTONDBLCLK, WM_MBUTTONDBLCLK, WM_RBUTTONDBLCLK
    End If
End Sub
Private Sub Private_InitFont()
    Dim uLF As LOGFONT, lngLen As Long
    ' fill LOGFONT structure with data from UserControl.Font
    With UserControl.Font
        If Len(.Name) >= LF_FACESIZE Then lngLen = LF_FACESIZE Else lngLen = Len(.Name)
        CopyMemory uLF.lfFaceName(0), ByVal .Name, lngLen
        uLF.lfHeight = -MulDiv(.Size, GetDeviceCaps(m_hDC, LOGPIXELSY), 72)
        uLF.lfItalic = .Italic
        If Not .Bold Then uLF.lfWeight = FW_NORMAL Else uLF.lfWeight = FW_BOLD
        uLF.lfUnderline = .Underline
        uLF.lfStrikeOut = .Strikethrough
        uLF.lfCharSet = .Charset
    End With
    If m_hFnt <> 0 Then DeleteObject m_hFnt
    m_hFnt = CreateFontIndirect(uLF)
    SendMessageW m_hWnd, WM_SETFONT, m_hFnt, ByVal &HFFFF&
End Sub
Private Function Private_IsFunctionSupported(ByRef FunctionName As String, ByRef ModuleName As String) As Boolean
    Dim lngModule As Long, blnUnload As Boolean
    ' get handle to module
    lngModule = GetModuleHandleA(ModuleName)
    ' if getting the handle failed...
    If lngModule = 0 Then
        ' try loading the module
        lngModule = LoadLibraryA(ModuleName)
        ' we have to unload it too if that succeeded
        blnUnload = (lngModule <> 0)
    End If
    ' now if we have a handle to module...
    If lngModule <> 0 Then
        ' see if the queried function is supported; return True if so, False if not
        Private_IsFunctionSupported = (GetProcAddress(lngModule, FunctionName) <> 0)
        ' see if we have to unload the module
        If blnUnload Then FreeLibrary lngModule
    End If
End Function
' this function is called by iHook_Before
Private Function Private_IsMenuClass(ByVal hWnd As Long) As Boolean
    Dim strClassName As String, lngClassLen As Long
    ' init string buffer
    strClassName = String$(128, vbNullChar)
    ' get class name
    lngClassLen = GetClassName(hWnd, strClassName, 128)
    ' the length doesn't match, return False
    If lngClassLen <> 6 Then Exit Function
    ' compare the class name to menu class name (always #32768)
    Private_IsMenuClass = (Left$(strClassName, lngClassLen) = "#32768")
End Function
Private Property Get Private_UTF16toUTF8(ByRef Text As String, Optional lFlags As Long) As String
    Static tmpArr() As Byte
    Dim tmpLen As Long, textLen As Long
    If LenB(Text) <> 0 Then
        textLen = Len(Text)
        tmpLen = LenB(Text) * 2 + 1
        ReDim Preserve tmpArr(tmpLen - 1)
        tmpLen = WideCharToMultiByte(65001, lFlags, ByVal StrPtr(Text), textLen, ByVal VarPtr(tmpArr(0)), tmpLen, ByVal 0&, ByVal 0&)
        If tmpLen > 0 Then
            If UBound(tmpArr) <> tmpLen Then ReDim Preserve tmpArr(tmpLen - 1)
            Private_UTF16toUTF8 = CStr(tmpArr)
        End If
    End If
End Property
Private Property Get Private_UTF8toUTF16(ByRef Text As String, Optional lFlags As Long) As String
    Static tmpArr() As Byte
    Dim tmpLen As Long, textLen As Long
    If LenB(Text) <> 0 Then
        textLen = LenB(Text)
        tmpLen = textLen * 2
        ReDim Preserve tmpArr(tmpLen + 1)
        tmpLen = MultiByteToWideChar(65001, lFlags, ByVal StrPtr(Text), textLen, ByVal VarPtr(tmpArr(0)), tmpLen) * 2
        If tmpLen > 0 Then
            If UBound(tmpArr) <> tmpLen Then ReDim Preserve tmpArr(tmpLen - 1)
            Private_UTF8toUTF16 = CStr(tmpArr)
        End If
    End If
End Property
Private Sub Private_WndHookProc(ByVal bBefore As Boolean, ByRef bHandled As Boolean, ByRef lReturn As Long, ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal lHookType As eHookType, ByRef lParamUser As Long)
    Dim CWP As CWPSTRUCT
    If lHookType = WH_CALLWNDPROC Then
        ' check the code (Const HC_ACTION = 0)
        If nCode <> 0& Then
        Else
            ' get the structure
            CopyMemory CWP, ByVal lParam, Len(CWP)
            ' check the hook message
            Select Case CWP.Message
                ' creating something
                Case WM_CREATE
                    If m_MenuhWnd = 0 Then If Not Private_IsMenuClass(CWP.hWnd) Then Else m_MenuhWnd = CWP.hWnd
                Case WM_DESTROY
                    If m_MenuhWnd = 0 Then Else If CWP.hWnd <> m_MenuhWnd Then Else m_MenuhWnd = 0
            End Select
        End If
    ElseIf m_HasFocus And lHookType = WH_KEYBOARD And m_MenuhWnd = 0 Then
        ' check the code (Const HC_ACTION = 0)
        If nCode <> 0& Then
        Else
            If lParam < 0 Then
                Select Case wParam
                    Case VK_DOWN, VK_END, VK_HOME, VK_LEFT, VK_RIGHT, VK_UP
                        SendMessageW m_hWnd, WM_KEYUP, wParam, lParam
                        lReturn = -1&
                        bHandled = True
                End Select
            Else
                Select Case wParam
                    Case VK_DOWN, VK_END, VK_HOME, VK_LEFT, VK_RIGHT, VK_UP
                        SendMessageW m_hWnd, WM_KEYDOWN, wParam, lParam
                        lReturn = -1&
                        bHandled = True
                End Select
            End If
        End If
    End If
End Sub
Private Sub Private_WndProcEdit(ByVal bBefore As Boolean, ByRef bHandled As Boolean, ByRef lReturn As Long, ByVal lng_hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef lParamUser As Long)
    Static KeyShift As UniTextShift
    Dim TME As TRACKMOUSEEVENT_STRUCT
    Dim XY(1) As Integer, Shift As UniTextShift, Button As UniTextMouseButton
    If bBefore Then
        If uMsg = WM_KILLFOCUS Then
            m_HasFocus = False
        ElseIf uMsg = WM_SETFOCUS Then
            If m_HasFocus = False Then SetFocus UserControl.hWnd: bHandled = True
        ElseIf m_UseEvents Then
            Select Case uMsg
                Case WM_CONTEXTMENU
                    RaiseEvent ContextMenu(bHandled)
                Case WM_KEYDOWN
                    If (lParam And &H40000000) = &H40000000 Then
                        RaiseEvent KeyPress(CInt(wParam And &HFFFF))
                    Else
                        If wParam = 10 Then
                            KeyShift = KeyShift Or [Shift Mask]
                        ElseIf wParam = 11 Then
                            KeyShift = KeyShift Or [Ctrl Mask]
                        End If
                        RaiseEvent KeyDown(CInt(wParam And &HFFFF), KeyShift)
                    End If
                Case WM_LBUTTONDOWN, WM_MBUTTONDOWN, WM_RBUTTONDOWN
                    ' this horribility is one reason to not use events...
                    CopyMemory XY(0), lParam, 4&
                    ' see key states
                    If (wParam And MK_SHIFT) = MK_SHIFT Then Shift = [Shift Mask]
                    If (wParam And MK_CONTROL) = MK_CONTROL Then Shift = Shift Or [Ctrl Mask]
                    ' button states
                    If (wParam And MK_LBUTTON) = MK_LBUTTON Then Button = [Left Button]
                    If (wParam And MK_MBUTTON) = MK_MBUTTON Then Button = Button Or [Middle Button]
                    If (wParam And MK_RBUTTON) = MK_RBUTTON Then Button = Button Or [Right Button]
                    ' raise the event
                    RaiseEvent MouseDown(Button, Shift, ScaleX(XY(0), vbPixels, m_ScaleMode), ScaleY(XY(1), vbPixels, m_ScaleMode))
            End Select
        End If
    ' BEFORE
    Else
    ' AFTER
        Select Case uMsg
            Case WM_KEYUP
                If wParam = 10 Then
                    KeyShift = KeyShift And Not [Shift Mask]
                ElseIf wParam = 11 Then
                    KeyShift = KeyShift And Not [Ctrl Mask]
                End If
                RaiseEvent KeyUp(CInt(wParam And &HFFFF), KeyShift)
            Case WM_MOUSEMOVE
                ' see if entering into the control
                If Not m_MouseOver Then
                    ' initialize TrackMouseEvent structure
                    TME.cbSize = Len(TME)
                    TME.dwFlags = TME_LEAVE
                    TME.hWndTrack = lng_hWnd
                    ' see which tracking API is available, if any
                    If m_TrackUser32 Then
                        TrackMouseEventUser32 TME
                    ElseIf m_TrackComCtl Then
                        TrackMouseEventComCtl TME
                    End If
                    ' set mouseover
                    m_MouseOver = True
                    ' raise event if using events
                    If m_UseEvents And (Not blnDesignTime) Then RaiseEvent MouseEnter
                End If
                ' see if need to raise events...
                If m_UseEvents Then
                    ' this horribility is one reason to not use events...
                    CopyMemory XY(0), lParam, 4&
                    ' see key states
                    If (wParam And MK_SHIFT) = MK_SHIFT Then Shift = [Shift Mask]
                    If (wParam And MK_CONTROL) = MK_CONTROL Then Shift = Shift Or [Ctrl Mask]
                    ' button states
                    If (wParam And MK_LBUTTON) = MK_LBUTTON Then Button = [Left Button]
                    If (wParam And MK_MBUTTON) = MK_MBUTTON Then Button = Button Or [Middle Button]
                    If (wParam And MK_RBUTTON) = MK_RBUTTON Then Button = Button Or [Right Button]
                    ' raise the event
                    RaiseEvent MouseMove(Button, Shift, ScaleX(XY(0), vbPixels, m_ScaleMode), ScaleY(XY(1), vbPixels, m_ScaleMode))
                End If
            Case WM_MOUSELEAVE
                m_MouseOver = False
                ' raise event if using events
                If m_UseEvents And (Not blnDesignTime) Then RaiseEvent MouseLeave
            Case WM_LBUTTONUP
                If m_UseEvents Then
                    ' this horribility is one reason to not use events...
                    CopyMemory XY(0), lParam, 4&
                    ' see key states
                    If (wParam And MK_SHIFT) = MK_SHIFT Then Shift = [Shift Mask]
                    If (wParam And MK_CONTROL) = MK_CONTROL Then Shift = Shift Or [Ctrl Mask]
                    ' button states
                    If (wParam And MK_LBUTTON) = MK_LBUTTON Then Button = [Left Button]
                    If (wParam And MK_MBUTTON) = MK_MBUTTON Then Button = Button Or [Middle Button]
                    If (wParam And MK_RBUTTON) = MK_RBUTTON Then Button = Button Or [Right Button]
                    ' raise the event
                    RaiseEvent MouseUp(Button, Shift, ScaleX(XY(0), vbPixels, m_ScaleMode), ScaleY(XY(1), vbPixels, m_ScaleMode))
                    ' click
                    RaiseEvent Click(vbLeftButton)
                End If
            Case WM_MBUTTONUP
                If m_UseEvents Then
                    ' this horribility is one reason to not use events...
                    CopyMemory XY(0), lParam, 4&
                    ' see key states
                    If (wParam And MK_SHIFT) = MK_SHIFT Then Shift = [Shift Mask]
                    If (wParam And MK_CONTROL) = MK_CONTROL Then Shift = Shift Or [Ctrl Mask]
                    ' button states
                    If (wParam And MK_LBUTTON) = MK_LBUTTON Then Button = [Left Button]
                    If (wParam And MK_MBUTTON) = MK_MBUTTON Then Button = Button Or [Middle Button]
                    If (wParam And MK_RBUTTON) = MK_RBUTTON Then Button = Button Or [Right Button]
                    ' raise the event
                    RaiseEvent MouseUp(Button, Shift, ScaleX(XY(0), vbPixels, m_ScaleMode), ScaleY(XY(1), vbPixels, m_ScaleMode))
                    ' click
                    RaiseEvent Click(vbMiddleButton)
                End If
            Case WM_RBUTTONUP
                If m_UseEvents Then
                    ' this horribility is one reason to not use events...
                    CopyMemory XY(0), lParam, 4&
                    ' see key states
                    If (wParam And MK_SHIFT) = MK_SHIFT Then Shift = [Shift Mask]
                    If (wParam And MK_CONTROL) = MK_CONTROL Then Shift = Shift Or [Ctrl Mask]
                    ' button states
                    If (wParam And MK_LBUTTON) = MK_LBUTTON Then Button = [Left Button]
                    If (wParam And MK_MBUTTON) = MK_MBUTTON Then Button = Button Or [Middle Button]
                    If (wParam And MK_RBUTTON) = MK_RBUTTON Then Button = Button Or [Right Button]
                    ' raise the event
                    RaiseEvent MouseUp(Button, Shift, ScaleX(XY(0), vbPixels, m_ScaleMode), ScaleY(XY(1), vbPixels, m_ScaleMode))
                    ' click
                    RaiseEvent Click(vbRightButton)
                End If
            Case WM_LBUTTONDBLCLK
                If m_UseEvents Then RaiseEvent DblClick(vbLeftButton)
            Case WM_MBUTTONDBLCLK
                If m_UseEvents Then RaiseEvent DblClick(vbMiddleButton)
            Case WM_RBUTTONDBLCLK
                If m_UseEvents Then RaiseEvent DblClick(vbRightButton)
        End Select
    End If
    
    'Debug.Print Format$(Time, "HH:MM:SS"), Hex$(uMsg), Hex$(wParam), Hex$(lParam), "myWndProcEdit", IIf(bBefore, "BEFORE", "AFTER")

End Sub
Private Sub Private_WndProc(ByVal bBefore As Boolean, ByRef bHandled As Boolean, ByRef lReturn As Long, ByVal lng_hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef lParamUser As Long)
    Dim XY(1) As Integer, Button As UniTextMouseButton, Shift As UniTextShift
    'Debug.Print Format$(Time, "HH:MM:SS"), Hex$(uMsg), Hex$(wParam), Hex$(lParam), "myWndProc", IIf(bBefore, "BEFORE", "AFTER")
    
    'If blnDesignTime Then Debug.Print Hex$(uMsg)
    
    If bBefore Then
        Select Case uMsg
            Case WM_CTLCOLOREDIT, WM_CTLCOLORSTATIC
                SetBkMode wParam, OPAQUE
                lReturn = m_BackClrBrush
                SetBkColor wParam, m_BackClr
                SetTextColor wParam, m_ForeClr
                bHandled = True
            Case WM_DESTROY
                If m_hWnd <> 0 Then
                    ssc_UnSubclass m_hWnd
'                    m_Text = Me.Text
                    DestroyWindow m_hWnd
                    m_hWnd = 0
                End If
                ssc_UnSubclass lng_hWnd
                Debug.Print "UniText: Ended subclassing! " & Hex$(lng_hWnd)
            Case WM_ERASEBKGND
                bHandled = True
                lReturn = -1&
        End Select
        If m_UseEvents Then
            Select Case uMsg
                Case WM_COMMAND
                    Select Case ((wParam And &HFFFF0000) \ &H10000) And &HFFFF&
                        Case EN_CHANGE
                            RaiseEvent Change
                        Case EN_UPDATE
                            RaiseEvent Update
                        Case EN_ALIGN_LTR_EC
                            
                        Case EN_ALIGN_RTL_EC
                            
                    End Select
            End Select
        End If
    ' BEFORE
    Else
    ' AFTER
        Select Case uMsg
            Case WM_PAINT
                If m_BorderStyle = [No Border] Then
                    Exit Sub
                ElseIf m_BorderStyle = [Flat3D] Then
                    DrawEdge UserControl.hDC, m_RC, BDR_SUNKENOUTER, BF_RECT
                Else
                    DrawEdge UserControl.hDC, m_RC, EDGE_SUNKEN, BF_RECT
                End If
        End Select
    End If
End Sub
